unit T_Main;

//{$DEFINE TEST}
interface
uses
  { test }
  //e_SIndex,

  Classes,
  WinTypes,
  e_Orbis01Projects,
  // GISLAYER
  f_LayImp,
  t_LayScr,
  t_LMCre,
// KERNEL
  Elements,
  e_ToolModel,
  e_Type,
  //HelpCtx,
  Tools,
// GLIB
  g_Elems,
  //t_HelW,
  t_MainTl,
  t_CmdLn,
// APP
  t_ControlGroup,
// LHC
  e_LHCProject,
  t_UserLHCAreaDialog,
// MAPPER
  e_Map,
  e_MSpace;
  //f_MSEdit,
  //f_Templ,
  //t_Guide,
  //t_LHPMap;



type

TOptions = class(TBaseOptions)
private
  {Scripts}
  FStartScript: string;
  FEndScript: string;
  {Files}
  //FPaletFile: string;
  {Directories}
  FDataDirectory: String;
  FServiceDirectory: String;
  FScriptDirectory: String;
  FTemplateDirectory: String;
  FFullUseMemory: boolean;
    FProjectDirectory: string;
    FProjectFile: string;
    FDontViewProjectIntroDialog: boolean;
    FAutoOpenLastProject: boolean;
    FExportScript: string;
    FImportScript: string;
    FEditorScript: string;
    FEditorDataScript: string;
    FExportControlDirectory: string;
    FEditorOn: boolean;
    FNewEditor: boolean;
    FImportParcelScript: string;
    FImportSRFScript: string;
    FImportZAKScript: string;
    FImportSLUScript: string;
    FImportDetLinesScript: string;
    FImportDETScript: string;
    FImportSkupinParcelScript: string;
    FExportZAKScript: string;
    FExportTEZScript: string;
    FExportSRFScript: string;
    FExportDETScript: string;
    FExportSLUScript: string;
    FImportTEZScript: string;
    FExportParScript: string;
    FExportSKPScript: string;
    FImportREVScript: string;
    FAutoSave: boolean;
    FAutoSaveInterval: integer;
    FStoreDirectory: string;
    FImportXMLScript: string;
    FActualKatastr: integer;
    FAfterLoadKatastrScript: string;
    FAfterLoadUserDataScript: string;
    FBeforeSaveUserDataScript: string;
    FAutoSaveUserData: boolean;
    FSaveContinualScript: string;
    FAutoSaveContinual: boolean;
    FNoQuestions: boolean;
    FAllowContinual: boolean;
    FContinual: boolean;
    FCreateContinualProjectsScript: string;
    procedure SetServiceDirectory(const aValue: string);
    function GetPaletFile: string;
    procedure SetPaletFile(const Value: string);
    procedure SetProjectDirectory(const Value: string);
    procedure SetProjectFile(const Value: string);
    procedure SetDontViewProjectIntroDialog(const Value: boolean);
    procedure SetAutoOpenLastProject(const Value: boolean);
    procedure SetExportScript(const Value: string);
    procedure SetImportScript(const Value: string);
    procedure SetEditorScript(const Value: string);
    procedure SetEditorDataScript(const Value: string);
    procedure SetExportControlDirectory(const Value: string);
    procedure SetEditorOn(const Value: boolean);
    procedure SetImportParcelScript(const Value: string);
    procedure SetImportDetLinesScript(const Value: string);
    procedure SetImportDETScript(const Value: string);
    procedure SetImportSkupinParcelScript(const Value: string);
    procedure SetImportSLUScript(const Value: string);
    procedure SetImportSRFScript(const Value: string);
    procedure SetImportZAKScript(const Value: string);
    procedure SetExportDETScript(const Value: string);
    procedure SetExportSLUScript(const Value: string);
    procedure SetExportSRFScript(const Value: string);
    procedure SetExportTEZScript(const Value: string);
    procedure SetExportZAKScript(const Value: string);
    procedure SetImportTEZScript(const Value: string);
    procedure SetExportParScript(const Value: string);
    procedure SetExportSKPScript(const Value: string);
    procedure SetImportREVScript(const Value: string);
    function GetRaster: boolean;
    procedure SetRaster(const Value: boolean);
    procedure SetAutoSave(const Value: boolean);
    procedure SetAutoSaveInterval(const Value: integer);
    procedure SetStoreDirectory(const Value: string);
    procedure SetImportXMLScript(const Value: string);
    procedure SetActualKatastr(const Value: integer);
    procedure SetAfterLoadKatastrScript(const Value: string);
    procedure SetAfterLoadUserDataScript(const Value: string);
    procedure SetBeforeSaveUserDataScript(const Value: string);
    procedure SetAutoSaveUserData(const Value: boolean);
    procedure SetSaveContinualScript(const Value: string);
    procedure SetAutoSaveContinual(const Value: boolean);
    procedure SetNoQuestions(const Value: boolean);
    procedure SetAllowContinual(const Value: boolean);
    procedure SetContinual(const Value: boolean);
    procedure SetCreateContinualProjectsScript(const Value: string);
published
  property   StartScript: string read FStartScript write FStartScript;
  property   EndScript: string read FEndScript write FEndScript;
  property   ImportScript: string read FImportScript write SetImportScript;
  property   ImportXMLScript: string read FImportXMLScript write SetImportXMLScript;
  property   ImportSkupinParcelScript: string read FImportSkupinParcelScript write SetImportSkupinParcelScript;
  property   ImportParcelScript: string read FImportParcelScript write SetImportParcelScript;
  property   SaveContinualScript: string read FSaveContinualScript write SetSaveContinualScript;
  property   CreateContinualProjectsScript: string read FCreateContinualProjectsScript write SetCreateContinualProjectsScript;
  property   AfterLoadKatastrScript: string read FAfterLoadKatastrScript write SetAfterLoadKatastrScript;
  property   BeforeSaveUserDataScript: string read FBeforeSaveUserDataScript write SetBeforeSaveUserDataScript;
  property   AfterLoadUserDataScript: string read FAfterLoadUserDataScript write SetAfterLoadUserDataScript;
  property   ImportREVScript: string read FImportREVScript write SetImportREVScript;
  property   ImportZAKScript: string read FImportZAKScript write SetImportZAKScript;
  property   ImportDETScript: string read FImportDETScript write SetImportDETScript;
  property   ImportDetLinesScript: string read FImportDetLinesScript write SetImportDetLinesScript;
  property   ImportSLUScript: string read FImportSLUScript write SetImportSLUScript;
  property   ImportSRFScript: string read FImportSRFScript write SetImportSRFScript;
  property   ImportTEZScript: string read FImportTEZScript write SetImportTEZScript;
  property   ExportParScript: string read FExportParScript write SetExportParScript;
  property   ExportSKPScript: string read FExportSKPScript write SetExportSKPScript;
  property   ExportZAKScript: string read FExportZAKScript write SetExportZAKScript;
  property   ExportDETScript: string read FExportDETScript write SetExportDETScript;
  property   ExportSLUScript: string read FExportSLUScript write SetExportSLUScript;
  property   ExportSRFScript: string read FExportSRFScript write SetExportSRFScript;
  property   ExportTEZScript: string read FExportTEZScript write SetExportTEZScript;
  property   ExportScript: string read FExportScript write SetExportScript;
  property   EditorScript: string read FEditorScript write SetEditorScript;
  property   EditorDataScript: string read FEditorDataScript write SetEditorDataScript;
  property   ExportControlDirectory: string read FExportControlDirectory write SetExportControlDirectory;
  property   ServiceDirectory: string read FServiceDirectory write SetServiceDirectory;
  property   DataDirectory: string read FDataDirectory write FDataDirectory;
  property   ScriptDirectory: string read FScriptDirectory write FScriptDirectory;
  property   StoreDirectory: string read FStoreDirectory write SetStoreDirectory;
  property   TemplateDirectory: string read FTemplateDirectory write FTemplateDirectory;
  property   ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
  property   PaletteFile: string read GetPaletFile write SetPaletFile;
  property   ProjectFile: string read FProjectFile write SetProjectFile;
  property   DontViewProjectIntroDialog: boolean read FDontViewProjectIntroDialog write SetDontViewProjectIntroDialog;
  property   AutoOpenLastProject: boolean read FAutoOpenLastProject write SetAutoOpenLastProject;
  property   EditorOn: boolean read FEditorOn write SetEditorOn;
  property   NewEditor: boolean read FNewEditor write FNewEditor;
  property   AutoSave: boolean read FAutoSave write SetAutoSave;
  property   AutoSaveInterval: integer read FAutoSaveInterval write SetAutoSaveInterval;
  property   RASTER: boolean read GetRaster write SetRaster;
  property   ActualKatastr: integer read FActualKatastr write SetActualKatastr;
  property   AutoSaveUserData: boolean read FAutoSaveUserData write SetAutoSaveUserData;
  property   AllowContinual: boolean read FAllowContinual write SetAllowContinual;
  property   AutoSaveContinual: boolean read FAutoSaveContinual write SetAutoSaveContinual;
  property   Continual: boolean read FContinual write SetContinual;
  property   NoQuestions: boolean read FNoQuestions write SetNoQuestions;
//  property   FullUseMemory: boolean read FFullUseMemory write FFullUseMemory default false;
end;

TOnGeneralEvent = procedure(_ID, Value: string) of object;
TOnNewModelEvent = procedure of object;
TOnSaveUserDataEvent = procedure(var ToSave: boolean) of object;
TOnContinualChangeEvent = procedure (aContinual: boolean) of object;
{$IFDEF FILEEVENT}
TFileEvent = procedure(const aFile: string) of object;
{$ENDIF}

TCheckLHCYearR = record
   LHC_YEAR:  integer;
   LHC_KOD :  integer;
   Check   :  boolean;
end;

TMainTool = class(TOldMainTool)
private
  FOptions: TOptions;
  FEditor: TControlGroup;
  ViewerIndex: integer;
  FSelectDone: boolean;
  FCancelProcess: boolean;
  //FAutomat: TAutomap;
  FScriptReading: boolean;
  FCommandLine: TCommandLine;
  FActualAction: integer;
    FActualActionVisible: boolean;
    FButtonCount: integer;
    FActualActionImageIndex: integer;
    FActualActionCaption: string;
    FActualActionScript: string;
    FProject: TORBISLHCProject;
    FCaptionString: string;
    FNoAutoSave: boolean;
    FAutoSaveNeeded: boolean;
    FOnNewModelEvent: TOnNewModelEvent;
    FOnUserLHCAreaDialog: TOnUserLHCAreaDialog;
    FOnSaveUserdataEvent: TOnSaveUserDataEvent;
    FOnNewDATAEvent: TOnNewModelEvent;
    FContinual: boolean;
    FOnContinualChangeEvent: TOnContinualChangeEvent;
    FOnRastersChangeEvent: TOnNewModelEvent;
    FScriptSender: TElement;
    FOnVrsChangeEvent: TOnNewModelEvent;
    FOnMapsCHangeEvent: TOnNewModelEvent;
    FOnTypChangeEvent: TOnNewModelEvent;
    FOnGeneralEvent: TOnGeneralEvent;
{$IFDEF FILEEVENT}
    FOn_FileAfterSaveEvent: TFileEvent;
    FOn_FileBeforeLoadEvent: TFileEvent;
    FOn_FileExistsEvent: TFileEvent;
    FNo_FileEvents: boolean;
    FOn_FileDeleteEvent: TFileEvent;
{$ENDIF}
    FContinualYear: integer;
    FUserDataSplitted: boolean;
    FNewUserDataSplitted: boolean;
    FDataProfileName: string;
    FNextUserDataSplitted: boolean;
  function  GetNOptions: TOptions; virtual;
  procedure SetNOptions(aValue: TOptions); virtual;
  procedure ExecScript(aFileName: string);
  function  GetText: string;
  procedure SetText(const aValue: string);
  function  GetExePath: string;
    procedure SetActualAction(const Value: integer);
    procedure SetActualActionCaption(const Value: string);
    procedure SetActualActionImageIndex(const Value: integer);
    procedure SetActualActionScript(const Value: string);
    procedure SetActualActionVisible(const Value: boolean);
    procedure SetButtonCount(const Value: integer);
    procedure SetNewImage(const Value: string);
    function GetActualActionCaption: string;
    function GetActualActionImageIndex: integer;
    function GetActualActionScript: string;
    function GetActualActionVisible: boolean;
    function GetActualActionHint: string;
    procedure setActualActionHint(const Value: string);
    procedure SetShowActionsCaptions(const Value: boolean);
    function GetImageHeight: integer;
    function GetImageWidth: integer;
    procedure SetImageHeight(const Value: integer);
    procedure SetImageWidth(const Value: integer);
    procedure SetProject(const Value: TORBISLHCProject);
    procedure SetCaptionString(const Value: string);
    function GetEditor: TControlGroup;
    procedure SetEditor(const Value: TControlGroup);
    function GetEditorModel: TToolModel;
    function GetScriptDirectory: string;
    function GetProjectChanged: boolean;
    procedure SetProjectChanged(const Value: boolean);
    procedure SetTimeToAutoSave(const Value: boolean);
    procedure SetNoAutoSave(const Value: boolean);
    procedure SetAutoSaveNeeded(const Value: boolean);
    procedure SetOnNewModelEvent(const Value: TOnNewModelEvent);
    procedure SetOnUserLHCAreaDialog(const Value: TOnUserLHCAreaDialog);
    procedure SetOnSaveUserdataEvent(const Value: TOnSaveUserDataEvent);
    procedure SetOnNewDATAEvent(const Value: TOnNewModelEvent);
    function GetContinual: boolean;
    procedure SetContinual(const Value: boolean);
    procedure SetOnContinualChangeEvent(
      const Value: TOnContinualChangeEvent);
    procedure SetNewProjectFromPath(const Value: string);
    procedure SetProjectFromFile(const Value: string);
    procedure SetDoSaveProjects(const Value: boolean);
    procedure SetOnRastersChangeEvent(const Value: TOnNewModelEvent);
    procedure SetRastersChange(const Value: boolean);
    procedure SetScriptSender(const Value: TElement);
    procedure SetOnVrsChangeEvent(const Value: TOnNewModelEvent);
    procedure SetVrsChange(const Value: boolean);
    procedure SetActualEditLayer(const Value: string);
    function GetActualEditLayer: string;
    procedure SetDoLoadMaps(const Value: boolean);
    procedure SetDoSaveMaps(const Value: boolean);
    procedure SetOnMapsCHangeEvent(const Value: TOnNewModelEvent);
    procedure SetMapsChange(const Value: boolean);
    function GetNo_BDE: boolean;
    procedure SetNo_BDE(const Value: boolean);
    procedure SetOnTypChangeEvent(const Value: TOnNewModelEvent);
    procedure SetTypChange(const Value: boolean);
{$IFDEF FILEEVENT}
    procedure SetOn_FileAfterSaveEvent(const Value: TFileEvent);
    procedure SetOn_FileBeforeLoadEvent(const Value: TFileEvent);
    procedure SetOn_FileExistsEvent(const Value: TFileEvent);
    procedure SetOn_FileDeleteEvent(const Value: TFileEvent);
{$ENDIF}
    procedure SetNo_FileEvents(const Value: boolean);
    function GetParams: TStringListElement;
    procedure SetOnGeneralEvent(const Value: TOnGeneralEvent);
    procedure SetGeneralEvent(const Value: string);
    procedure SetContinualYear(const Value: integer);
    function GetEditLayers: TEntity;
    function GetActualEditLayerChanged: boolean;
    procedure SetActualEditLayerChanged(const Value: boolean);
    procedure SetNewUserDataSplitted(const Value: boolean);
    procedure SetUserDataSplitted(const Value: boolean);
    procedure SetDataProfileName(const Value: string);
    procedure SetDoSaveProjectData(const Value: boolean);
    procedure SetNextUserDataSplitted(const Value: boolean);
protected
  procedure ReadParamsFromIni; override;
  procedure ReadParams; override;
  procedure WriteParamsToIni; override;
  function  GetIniFileName: string; override;
  function  GetMinProgress: integer;
  function  GetMaxProgress: integer;
  function  GetProgress: integer;
  function  GetProgressVisible: boolean;
  procedure SetMinProgress(aValue: integer);
  procedure SetMaxProgress(aValue: integer);
  procedure SetProgress(aValue: integer);
  procedure SetProgressVisible(aValue: boolean);
public
   StartDir: string;
   Chk_LHC_Attr:  TCheckLHCYearR;
   constructor Create; override;
   destructor  Destroy; override;
   procedure   DoIt; override;
   procedure   DoItReActivate;
   procedure   LoadplugIns; override;
   procedure   DelFil(aFileName: string);
   procedure   RenFil(aFileName, aFileNameN: string);
   procedure   SetUpAutoSave;
   procedure   CheckModelVersion;
   procedure   SetModelVersion;
   procedure   CreateNewModel;
   procedure   CreateNewDATA;
   procedure   CreateContinualProjects;
   procedure   OpenLastProject;
   procedure   LoadProjectFromFile(aFile: string);
   procedure   SaveProject;
   procedure   SaveProjectAsContinual;
   procedure   CheckProjectForSave;
   procedure   CheckUserDataForSave;
   procedure   DeleteProject(aProjectName: string);
   function    CreateProjectByPath(Value: string): TOrbisLHCProject;
   function    GetKatastrFileName(aID: integer): string;
   function    GetUserDataFileName: string;
   function    GetUserDataOldFileName: string;
   function    GetUserDataLHCYearstring: string;
   function    FindProjectName: string;
   function    LoadProjectDataFormORB(const aFileName, DataType: string): integer;
   procedure   LoadProjectData;
   function    LoadUserDataCheckSplit: boolean;
   function    LoadUserDataSplitted: boolean;
   function    LoadUserData(_FileName: string): boolean;
   function    Synchronize_with_mobile_user_data_layer(aLayer, MobileFile, DesktopFile, MediaFile: string): integer;
   function    Synchronize_with_New_user_data_layer(aLayer, NewFile, DesktopFile, MediaFile: string): integer;
   function    SplitUserData(LHC_KOD, LHC_Year: integer): boolean;
   function    SetUserDataUUID(LHC_KOD, LHC_Year: integer; aUserID: string; SetUserID: boolean): boolean;
   function    DeleteUserLayer(LHC_KOD, LHC_Year: integer; aLayerName: string; LHC_Splitted: boolean): boolean;
   function    DeleteUserPhysicalLayer(LHC_KOD, LHC_Year: integer; aLayerName, aLayerType: string; LHC_Splitted: boolean): boolean;
   function    QueryUserLayerCounts(LHC_KOD, LHC_Year: integer; aLayerName: string; var aCountR: TOrbis01UserLayerCounts; LHC_Splitted: boolean): boolean;
   procedure   LoadKatastr(aID: integer);
   procedure   LoadKatastrData(const aFileName: string);
   procedure   SaveData(aData: TElement; aFileName: string);
   procedure   SaveProjectData;
   procedure   SaveUserData(_FileName: string; ActualLayerOnly: boolean);
   procedure   SaveUserDataSplitted;
   procedure   SaveKatastrData(const aFileName: string);
   procedure   LoadProjectionInfo;
   procedure   SaveProjectionInfo;
   procedure   LoadMaps;
   procedure   SaveMaps;
   procedure   LoadProjects;
   procedure   SaveProjects;
   procedure   LoadKatastrs;
   procedure   SaveKatastrs;
   procedure   LoadRasters;
   procedure   SaveRasters;
   procedure   LoadUserLayers;
   procedure   SaveUserLayers;
   procedure   CHeckProjectRasters;
   procedure   SaveProjectRasters;
   procedure   SetupProjectRasters;
   procedure   CheckProjectVRS;
   procedure   SaveProjectVRS;
   procedure   SetupProjectVRS;
   procedure   CheckProjectTYP;
   procedure   SaveProjectTYP;
   procedure   SetupProjectTYP;
   function    JoinProjects(aSourcePath: string): integer;
   procedure   LoadZnDBF;
   procedure   ImportData;
   procedure   LoadEditorModelFile;
   procedure   SaveEditorModelFile;
   procedure   SetEditorData;
   procedure   ViewProjectIntroDialog;
   procedure   RunStartScripts; override;
   procedure   NewKatastr(const aPath: string; aID: integer);
   procedure   PrintMap;
   function    GetOptions: TBaseOptions; override;
   procedure   SetOptions(aValue: TBaseOptions); override;
   procedure  on_tm_SetOptions(var Handled: boolean); virtual;
   procedure  on_tm_SetUpProject(var Handled: boolean); virtual;
   procedure  on_tm_ProjectManager(var Handled: boolean); virtual;
   procedure  on_tm_QuitTask; override;
   procedure  on_tm_NewProject(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OpenProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProject(var Handled: boolean); virtual;
   procedure  On_tm_SaveProjectAs(var Handled: boolean); virtual;
   procedure  On_tm_Import(var Handled: boolean); virtual;
   procedure  On_tm_Export(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ImportBlk(var Handled: boolean); virtual;
   procedure  On_tm_Editor(var Handled: boolean); virtual;
   procedure  On_tm_ModelChanged(var Handled: boolean); virtual;
   procedure  on_tm_SelectDataDirectory(var Handled: boolean); virtual;
   procedure  On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   //procedure  On_tm_AddAndPrintView(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_OIL(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  On_tm_SetPalette(var Handled: boolean); virtual;
   procedure  on_tm_EndOfDDEScript; virtual;
   procedure  on_tm_SetDDEResult; virtual;
   procedure  on_tm_Intro; virtual;
   procedure  on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_Param(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_FileBeforeLoad(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_FileAfterSave(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_FileExists(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  on_tm_FileDelete(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure  ExecuteMacro(M: TStrings); virtual;
   procedure  AddWorkTools; override;
   procedure  ReadIniFile;
   procedure  ProcessUserLHCAreaDialog(NewObject: boolean; Area: double; Skupina: TElement; var UserID,Group,Color,Symbol,aresult: integer; var Props: string);
   function   GetProjectDataDirectoryEx: string; override;
   procedure  CheckLHCYear(LHC_KOD,LHC_Year: integer; Setup: boolean);
   procedure  CheckDataProfile;

   property   SelectDone: boolean read FSelectDone write FSelectDone;
   property   CancelProcess: boolean read FCancelProcess write FCancelProcess;
   property   ScriptReading: boolean read FScriptReading write FScriptReading;
   property   ExePath: string read GetExePath;
   property   ButtonCount: integer read FButtonCount write SetButtonCount;
   property   CaptionString: string read FCaptionString write SetCaptionString;
   property   EditorModel: TToolModel read GetEditorModel;
   property   ScriptDirectory: string read GetScriptDirectory;
   property   AutoSaveNeeded: boolean read FAutoSaveNeeded write SetAutoSaveNeeded;
published
   property   OnGeneralEvent: TOnGeneralEvent read FOnGeneralEvent write SetOnGeneralEvent;
   property   OnNewDATAEvent: TOnNewModelEvent read FOnNewDATAEvent write SetOnNewDATAEvent;
   property   OnNewModelEvent: TOnNewModelEvent read FOnNewModelEvent write SetOnNewModelEvent;
   property   OnRastersChangeEvent: TOnNewModelEvent read FOnRastersChangeEvent write SetOnRastersChangeEvent;
   property   OnMapsCHangeEvent: TOnNewModelEvent read FOnMapsCHangeEvent write SetOnMapsCHangeEvent;
   property   OnVrsChangeEvent: TOnNewModelEvent read FOnVrsChangeEvent write SetOnVrsChangeEvent;
   property   OnTypChangeEvent: TOnNewModelEvent read FOnTypChangeEvent write SetOnTypChangeEvent;
   property   OnUserLHCAreaDialog: TOnUserLHCAreaDialog read FOnUserLHCAreaDialog write SetOnUserLHCAreaDialog;
   property   OnSaveUserdataEvent: TOnSaveUserDataEvent read FOnSaveUserdataEvent write SetOnSaveUserdataEvent;
   property   OnContinualChangeEvent: TOnContinualChangeEvent read FOnContinualChangeEvent write SetOnContinualChangeEvent;
{$IFDEF FILEEVENT}
   property On_FileBeforeLoadEvent: TFileEvent read FOn_FileBeforeLoadEvent write SetOn_FileBeforeLoadEvent;
   property On_FileAfterSaveEvent: TFileEvent read FOn_FileAfterSaveEvent write SetOn_FileAfterSaveEvent;
   property On_FileExistsEvent: TFileEvent read FOn_FileExistsEvent write SetOn_FileExistsEvent;
   property On_FileDeleteEvent: TFileEvent read FOn_FileDeleteEvent write SetOn_FileDeleteEvent;
{$ENDIF}
   property   Options: TOptions read GetNOptions write SetNOptions;
   property   ExecuteScript: string write ExecScript stored false;
   property   ScriptSender: TElement read FScriptSender write SetScriptSender;
   procedure  SetParam(const aName,aValue: string);
   function   GetParam(aName: string): string;
   function   GetParamAsBoolean(aName: string): boolean;
   property   Text: string read GetText write SetText;
   property   MinProgress: integer read GetMinProgress write SetMinProgress;
   property   MaxProgress: integer read GetMaxProgress write SetMaxProgress;
   property   Progress: integer read GetProgress write SetProgress;
   property   ProgressVisible: boolean read GetProgressVisible write SetProgressVisible;
   property   NewImage: string write SetNewImage;
   property   ActualAction: integer read FActualAction write SetActualAction;
   property   ActualActionVisible: boolean read GetActualActionVisible write SetActualActionVisible;
   property   ActualActionScript: string read GetActualActionScript write SetActualActionScript;
   property   ActualActionImageIndex: integer read GetActualActionImageIndex write SetActualActionImageIndex;
   property   ActualActionCaption: string read GetActualActionCaption write SetActualActionCaption;
   property   ActualActionHint: string read GetActualActionHint write setActualActionHint;
   property   ImageHeight: integer read GetImageHeight write SetImageHeight;
   property   ImageWidth: integer read GetImageWidth write SetImageWidth;
   property   ShowActionCaptions: boolean write SetShowActionsCaptions;
   property   Project: TORBISLHCProject read FProject write SetProject;
   property   Editor: TControlGroup read GetEditor write SetEditor;
   property   ProjectChanged: boolean read GetProjectChanged write SetProjectChanged;
   property   TimeToAutoSave: boolean write SetTimeToAutoSave;
   property   NoAutoSave: boolean read FNoAutoSave write SetNoAutoSave;
   property   Continual: boolean read GetContinual write SetContinual;
   property   ContinualYear: integer read FContinualYear write SetContinualYear;
   property   NewProjectFromPath: string write SetNewProjectFromPath;
   property   ProjectFromFile: string write SetProjectFromFile;
   property   DoSaveProjects: boolean write SetDoSaveProjects;
   property   GeneralEvent: string write SetGeneralEvent;
   property   RastersChange: boolean write SetRastersChange;
   property   MapsChange: boolean write SetMapsChange;
   property   VrsChange: boolean write SetVrsChange;
   property   TypChange: boolean write SetTypChange;
   property   ActualEditLayer: string read GetActualEditLayer write SetActualEditLayer;
   property   ActualEditLayerChanged: boolean read GetActualEditLayerChanged write SetActualEditLayerChanged;
   property   EditLayers: TEntity read GetEditLayers;
   property   DoLoadMaps: boolean write SetDoLoadMaps;
   property   DoSaveMaps: boolean write SetDoSavemaps;
   property   DoSaveProjectData: boolean write SetDoSaveProjectData;
   property   No_BDE: boolean read GetNo_BDE write SetNo_BDE;
   property   No_FileEvents: boolean read FNo_FileEvents write SetNo_FileEvents;
   property   Params: TStringListElement read GetParams;
   property   UserDataSplitted: boolean read FUserDataSplitted write SetUserDataSplitted;
   property   NextUserDataSplitted: boolean read FNextUserDataSplitted write SetNextUserDataSplitted;
   property   NewUserDataSplitted: boolean read FNewUserDataSplitted write SetNewUserDataSplitted;
   property   DataProfileName: string read FDataProfileName write SetDataProfileName;
end;



implementation
uses
  { Test}

  Controls, Forms, Dialogs, IniFiles, SysUtils, Graphics, WinProcs,
  StrUtils,
  System.DateUtils,
  //FileCtrl,
  ActnList,
  _IniFile,
// KERNEL
  E_Files,
  M_Orbis,
  u_Global,
  u_String,
  e_WCS,
  Worlds,
// OIL
  t_Select,
  t_FreeNoGeometryElements,
  t_AreMak,
  t_FreeDuplicateGeometryElements,
  t_GeometryChecks,
// EXPLORER
{$IFNDEF WIN64}
  f_CmdLn,
{$ENDIF}
  T_Explor,
// GLIB
  //t_Grp,
// SPACE
  e_Reg,
// SYMBOL
  u_Symbol,
// INTERPRET
//Device
  e_ProjectionInfo,
  e_IScrpt,
  e_ThematicMap,
  e_LHCModel,
// 0TEMP
  //e_DClass,
  f_SelDir,
  T_EdiPro,
  t_Saver,
  t_Loader,
// TOPOL
  //e_TplPrp,
  T_TisCre,
  T_TopImp,//!!!!!!!!!!!!!!!!!!!!!!
  E_Color,
  //f_YesNo,
// GUI
  //t_Intera,
// MAIN
  //F_Main,
  //f_Option,
  //F_Start,
  M_Proj,
// APP
  t_ProjectIntroDialog,
  t_Orbis01PDialog,
  t_ConfirmDialog,
  t_GraphicForm,
  f_GraphicForm,
// LHC
  t_LHCProjectDialog,
 t_LHCImportDialog,
  t_LHCProjectManager,
  //!!! t_exportLHCDialog,
  //!!! t_ExpLHC,
  //!!! t_HelLHC,
// FILES
  u_File,
  e_GeometryElement,
  e_GeometryEx,
  e_TopolElements,
  e_Sort,
// REG
// RASTER
  e_Raster,
  FileVersion,
  u_cktm;
// MAPPER
  //t_MSEdit,
  //t_VieMap;

{TOptions}



function TOptions.GetPaletFile: string;
begin
   Result := PaletFile;
end;

function TOptions.GetRaster: boolean;
begin
   result := UseRasters;
end;

procedure TOptions.SetActualKatastr(const Value: integer);
begin
  FActualKatastr := Value;
end;

procedure TOptions.SetAfterLoadKatastrScript(const Value: string);
begin
  FAfterLoadKatastrScript := Value;
end;

procedure TOptions.SetAfterLoadUserDataScript(const Value: string);
begin
  FAfterLoadUserDataScript := Value;
end;

procedure TOptions.SetAllowContinual(const Value: boolean);
begin
  FAllowContinual := Value;
end;

procedure TOptions.SetAutoOpenLastProject(const Value: boolean);
begin
   FAutoOpenLastProject := Value;
end;

procedure TOptions.SetAutoSave(const Value: boolean);
begin
  FAutoSave := Value;
end;

procedure TOptions.SetAutoSaveContinual(const Value: boolean);
begin
  FAutoSaveContinual := Value;
end;

procedure TOptions.SetAutoSaveInterval(const Value: integer);
begin
  FAutoSaveInterval := Value;
end;

procedure TOptions.SetAutoSaveUserData(const Value: boolean);
begin
  FAutoSaveUserData := Value;
end;

procedure TOptions.SetBeforeSaveUserDataScript(const Value: string);
begin
  FBeforeSaveUserDataScript := Value;
end;

procedure TOptions.SetContinual(const Value: boolean);
begin
  FContinual := Value;
end;

procedure TOptions.SetCreateContinualProjectsScript(const Value: string);
begin
  FCreateContinualProjectsScript := Value;
end;

procedure TOptions.SetDontViewProjectIntroDialog(const Value: boolean);
begin
  FDontViewProjectIntroDialog := Value;
end;

procedure TOptions.SetEditorDataScript(const Value: string);
begin
  FEditorDataScript := Value;
end;

procedure TOptions.SetEditorOn(const Value: boolean);
begin
  FEditorOn := Value;
end;

procedure TOptions.SetEditorScript(const Value: string);
begin
  FEditorScript := Value;
end;

procedure TOptions.SetExportControlDirectory(const Value: string);
begin
  FExportControlDirectory := Value;
end;

procedure TOptions.SetExportDETScript(const Value: string);
begin
  FExportDETScript := Value;
end;

procedure TOptions.SetExportParScript(const Value: string);
begin
  FExportParScript := Value;
end;

procedure TOptions.SetExportScript(const Value: string);
begin
  FExportScript := Value;
end;

procedure TOptions.SetExportSKPScript(const Value: string);
begin
  FExportSKPScript := Value;
end;

procedure TOptions.SetExportSLUScript(const Value: string);
begin
  FExportSLUScript := Value;
end;

procedure TOptions.SetExportSRFScript(const Value: string);
begin
  FExportSRFScript := Value;
end;

procedure TOptions.SetExportTEZScript(const Value: string);
begin
  FExportTEZScript := Value;
end;

procedure TOptions.SetExportZAKScript(const Value: string);
begin
  FExportZAKScript := Value;
end;

procedure TOptions.SetImportDetLinesScript(const Value: string);
begin
  FImportDetLinesScript := Value;
end;

procedure TOptions.SetImportDETScript(const Value: string);
begin
  FImportDETScript := Value;
end;

procedure TOptions.SetImportParcelScript(const Value: string);
begin
  FImportParcelScript := Value;
end;

procedure TOptions.SetImportREVScript(const Value: string);
begin
  FImportREVScript := Value;
end;

procedure TOptions.SetImportScript(const Value: string);
begin
  FImportScript := Value;
end;

procedure TOptions.SetImportSkupinParcelScript(const Value: string);
begin
  FImportSkupinParcelScript := Value;
end;

procedure TOptions.SetImportSLUScript(const Value: string);
begin
  FImportSLUScript := Value;
end;

procedure TOptions.SetImportSRFScript(const Value: string);
begin
  FImportSRFScript := Value;
end;

procedure TOptions.SetImportTEZScript(const Value: string);
begin
  FImportTEZScript := Value;
end;

procedure TOptions.SetImportXMLScript(const Value: string);
begin
  FImportXMLScript := Value;
end;

procedure TOptions.SetImportZAKScript(const Value: string);
begin
  FImportZAKScript := Value;
end;

procedure TOptions.SetNoQuestions(const Value: boolean);
begin
  FNoQuestions := Value;
end;

procedure TOptions.SetPaletFile(const Value: string);
begin
   if Value <> PaletFile then
   begin
      PaletFile := Value;
      if Value = '' then
         InitSystemColorPalette
      else
         NactiBarvickuZeSouboru(Value);
   end
end;

procedure TOptions.SetProjectDirectory(const Value: string);
begin
   FProjectDirectory := Value;
end;

procedure TOptions.SetProjectFile(const Value: string);
begin
  FProjectFile := Value;
end;

procedure TOptions.SetRaster(const Value: boolean);
begin
   UseRasters := value;
end;

procedure TOptions.SetSaveContinualScript(const Value: string);
begin
   FSaveContinualScript := Value;
end;

procedure TOptions.SetServiceDirectory(const aValue: string);
begin
   FServiceDirectory := aValue;
   PathOfLibraries := GetAbsolutePath(aValue);
   RemoveBackSlash(PathOfLibraries);
end;


procedure TOptions.SetStoreDirectory(const Value: string);
begin
  FStoreDirectory := Value;
end;

{TMainTool}

function TMainTool.GetIniFileName: string;
var
   S: string;
begin
   S := 'Orbis01.ini';
   result := GetAbsolutePath(S);
end;


function  TMainTool.GetExePath: string;
begin
  result := ExtractFilePath(ParamStr(0));
  CheckBackSlash(result);
end;


function  TMainTool.GetMinProgress: integer;
begin
   result := 0;
   //result := MainForm.ProgressBar.Min;
end;

function  TMainTool.GetMaxProgress: integer;
begin
   result := 0;
   //result := MainForm.ProgressBar.Max;
end;

function TMainTool.GetParam(aName: string): string;
var
   P: TStringListElement;
begin
   result := '';
   P := Params;
   result := P.GetStringByName(aName);
end;

function TMainTool.GetParamAsBoolean(aName: string): boolean;
var
   S: string;
begin
   result := false;
   S := UpperCase(GetParam(aName));
   if S = 'TRUE' then
      result := true;
end;

function TMainTool.GetParams: TStringListElement;
begin
   result := TStringListElement(World.ObjectModel.FindOrCreateElementName(TStringListElement,'PARAMS'));
end;

function  TMainTool.GetProgress: integer;
begin
   result := 0;
   //result := MainForm.ProgressBar.Position;
end;

function  TMainTool.GetProgressVisible: boolean;
begin
   result := false;
   //result := MainForm.ProgressBar.Visible;
end;

procedure TMainTool.SetMinProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Min := aValue;
end;

procedure TMainTool.SetMaxProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Max := aValue;
end;

procedure TMainTool.SetParam(const aName, aValue: string);
var
   P: TStringListElement;
begin
   P := Params;
   P.SetStringByName(aName, aValue);
end;

procedure TMainTool.SetProgress(aValue: integer);
begin
   //MainForm.ProgressBar.Position := aValue;
end;

procedure TMainTool.SetProgressVisible(aValue: boolean);
begin
   //MainForm.ProgressBar.Visible := aValue;
end;



constructor TMainTool.Create;
var
   S: string;
begin
  inherited Create;
  getDir(0, S);
  //Options.WorkingDirectory := S;
  Options.DataDirectory := S;
end;


destructor  TMainTool.Destroy;
begin
   //if Assigned(FTemplateLibrary) then FTemplateLibrary.Free;
   inherited Destroy;
end;




function  TMainTool.GetOptions: TBaseOptions;
begin
   if FOptions = nil then
   begin
      FOptions := TOptions.Create;
      AddElement(FOptions);
   end;
   result := FOptions;
end;

function  TMainTool.GetNOptions: TOptions;
begin
   result := TOptions(GetOptions);
end;


function TMainTool.GetNo_BDE: boolean;
begin
   result := NoBDE;
end;

procedure TMainTool.SetOptions(aValue: TBaseOptions);
begin
   if FOptions <> nil then
   begin
      FreeElement(FOptions);
      FOptions := nil;
   end;
   FOptions := TOptions(aValue);
end;

procedure TMainTool.SetNOptions(aValue: TOptions);
begin
   SetOptions(aValue);
end;

procedure TMainTool.SetNo_BDE(const Value: boolean);
begin
   NoBDE := Value;
end;

procedure TMainTool.SetNo_FileEvents(const Value: boolean);
begin
   FNo_FileEvents := Value;
end;

procedure TMainTool.ExecScript(aFileName: string);
var
   CmdLn: TCommandLine;
   S: string;
begin
   if aFileName = '' then exit;
   S := aFileName;
   S := StringReplace(S,'$SCRIPT',Options.ScriptDirectory,[rfReplaceAll, rfIgnoreCase]);
   S := GetAbsolutePath(S);
   CmdLn := TCommandLine.Create;
   CmdLn.FileName := S;
   CmdLn.DoIt;
   CmdLn.Free;
   Application.ProcessMessages;
   //CommandLine.FileName:= aFileName;
   //CommandLine.DoIt
end;





procedure TMainTool.DoIt;
var
   S: string;
begin
   getDir(0, S);
   //Options.WorkingDirectory := S;
   Options.DataDirectory := S;
   inherited;
   Application.ProcessMessages;
   //CaptionString := MainForm.Caption + '- ';
   PostMsg(tm_Intro,Self,nil,false);
   Text := 'Inicializace O.K.';
   //SetupAutoSave;
   LoadProjects;
   LoadRasters;
   LoadKatastrs;
   LoadUserLayers;
end;





procedure TMainTool.DoItReActivate;
begin
   CreateNewModel;
   Application.ProcessMessages;
   //SetupAutoSave;
   LoadProjects;
   LoadRasters;
   LoadKatastrs;
   LoadUserLayers;
end;

procedure TMainTool.ReadParamsFromIni;
//var
//   IniFile: TIniFile;
begin
   inherited ReadParamsFromIni;
//   IniFile:= TIniFile.Create(IniFileName);
   //NactiBarvickuZeSouboru(IniFile.ReadString('OPTIONS', 'PALETFILE', AddBackSlash(PathOfLibraries) + 'PALETA.TXT'));
//   IniFile.Free;

end;



procedure TMainTool.RenFil(aFileName, aFileNameN: string);
begin
   {$IFDEF FILEEVENT}
      PostTextMsg(tm_FileExists,aFileName,nil);
      Application.ProcessMessages;
   {$ENDIF}
   if FileExists(aFileName) then
   begin
      RenameFile(aFileName, aFileNameN);
     {$IFDEF FILEEVENT}
        PostTextMsg(tm_FileDelete,aFileName,nil);
        Application.ProcessMessages;
        PostTextMsg(tm_FileAfterSave,aFileNameN,nil);
        Application.ProcessMessages;
     {$ENDIF}
   end;
end;

procedure TMainTool.ReadParams;
begin
   //ReadParamsFromIni;
end;




procedure TMainTool.WriteParamsToIni;
(*
var
   Save: TSave;
   IniFile: TRealIniFile;
   B: boolean;
*)
begin
   //IniFile:= TRealIniFile.Create(IniFileName);
   (*
   if (PaletFile <> '') and FileExists(PaletFile) then
      IniFile.WriteString('OPTIONS', 'PALETFILE', PaletFile);
   *)
   //IniFile.Free;

   {
   Options.PaletFile := PaletFile;
   }
   inherited WriteParamsToIni;
   (*
   Save := TSave.Create;
   Save.FileName := ExePath + 'SOURCE.ORB';
   Save.Input := ???;
   Save.DoIt;
   Save.Free;
   *)
   //SaveTemplateLibrary

end;


procedure  TMainTool.on_tm_SetOptions(var Handled: boolean);
var
   //D: TF_Options;
   B: boolean;
begin
   Handled := true;
   {
   B := MainForm.Timer.Enabled;
   MainForm.Timer.Enabled := false;
   Application.CreateForm(TF_Options, D);

   D.ed_Script.Text := Options.ScriptDirectory;
   D.ed_EXE.Text := ExePath;
   D.ed_Service.Text := Options.ServiceDirectory;
   D.ed_Project.Text := Options.ProjectDirectory;
   D.c_DontViewDialog.Checked := Options.DontViewProjectIntroDialog;
   D.c_OpenLastProject.Checked := Options.AutoOpenLastProject;
   D.cb_AutoSave.Checked := Options.AutoSave;
   if Options.AutoSaveInterval in [1..180] then
      D.ed_AutoSaveInterval.Value := Options.AutoSaveInterval;
   D.ed_AutoSaveInterval.Enabled := Options.AutoSave;
   if D.ShowModal = mrOk then
   begin
      Options.ScriptDirectory := D.ed_Script.Text;
      Options.ServiceDirectory := D.ed_Service.Text;
      PathOfLibraries:= Options.ServiceDirectory;
      PathOfLibraries:= RemoveBackSlash(PathOfLibraries);
      Options.ProjectDirectory := D.ed_Project.Text;
      Options.DontViewProjectIntroDialog := D.c_DontViewDialog.Checked;
      Options.AutoOpenLastProject := D.c_OpenLastProject.Checked;
      Options.AutoSave := D.cb_AutoSave.Checked;
      Options.AutoSaveInterval := D.ed_AutoSaveInterval.Value;
      SetUpAutoSave;
   end
   else
      MainForm.Timer.Enabled := B;
   //MainForm.b_Directory.Hint := 'Data: ' + Options.DataDirectory;
   //MainForm.l_Data.Caption := Options.DataDirectory;
   D.Free;
   }
end;


procedure  TMainTool.on_tm_QuitTask;
var
   i: longInt;
begin
   If not IsPossibleToQuit then exit;
   WriteParamsToIni;
   CheckProjectForSave;
   case MessageDlg('Opravdu ukonit aplikaci ?', mtConfirmation, mbYesNoCancel, 0) of
      mrYes:
      begin
         Application.Terminate;
      end;
   end;
end;



procedure  TMainTool.On_tm_NewProject(var aMessage: TOrbisMessage; var Handled: boolean);
var
   D: TOrbis01PDialog;
   CD: TOrbisConfirmDialog;
   P: TORBISLHCproject;
   S : string;
begin
   Error := 0;
   if not (aMessage is TOrbisTextMessage) or (TOrbisTextMessage(aMessage).Text = '') then
   begin
      D := TOrbis01PDialog.Create;
      //D.Caption := 'Nov projekt';
      D.ProjectDirectory := Options.ProjectDirectory;
      D.DoIt;
      if D.result <> 1 then  exit;
      P := TORBISLHCproject(D.Output);
   end
   else
   begin
      S := TOrbisTextMessage(aMessage).Text;
      P := CreateProjectByPath(S);
      if P = nil then
      begin
         Error := 1;
         exit;
      end;
   end;
   Continual := false; // vypiname souvisle zobrazeni
   //P := TORBISLHCproject(D.Output);
   // projektovy soubor za tepla ulozime
   //S := Options.ProjectDirectory;
   //CheckBackSlash(S);
   //S := S+P.Name+'.OPR';
   //S := GetAbsolutePath(S);
   // ulozeni projektu se odklada az za import
   //-------------------------------------------
   //Save := TSave.Create;
   //Save.FileName := S;
   //Save.Input := P;
   //Save.DoIt;
   //Save.Free;
   //-------------------------------------------
   StartProgress('Tvorba novho projektu: '+P.Name,0,0);
   // Vycistime Model
   CheckProjectForSave;
   //CreateNewModel;
   CreateNewDATA;
   Project := P;
   //World.SystemRegister.FreeElement(World.SystemRegister.FindElementName('Projection'));
   //ExecuteScript := 'LED\ProjectionInfoModel.OIL';
   // co takhle nejakej import
   {
   CD := TOrbisConfirmDialog.Create;
   CD.Text := 'Byl vytvoen nov projekt s nzvem '+P.Name+
          '. Dosud neobsahuje dn data - pejete si je importovat z TopoLu?';
   CD.Caption := 'Nov projekt';
   CD.DoIt;
   }
   //Case CD.Result of
   //   1:
      begin
         //ImportData;
         //SetEditorData;
         PostMsg(tm_Import,nil,nil,false);
      end;
   //end;
   //CD.Free;
   EndProgress;
end;


procedure  TMainTool.On_tm_OpenProject(var Handled: boolean);
var
   Load: TLoad;
   P: TORBISLHCProject;
begin
   {
   MainForm.OpenDialog.InitialDir := Options.ProjectDirectory;
   if MainForm.OpenDialog.Execute then
   begin
      LoadProjectFromFile(MainForm.OpenDialog.FileName);
   end;
   if Options.EditorOn and (Editor = nil) then
      PostMsg(tm_Editor,Self,nil,false);
   }
end;


procedure  TMainTool.On_tm_ImportBlk(var Handled: boolean);
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
(*
   Handled := true;
   ExecuteScript := Options.RunScript;
*)
(*
  BR:= TTopoLBlokReader.CreateBlock('d:\0\m\maly\DET.BLK');
  E := TRectEntity.Create;
  E.Name := 'DATA';
  World.ObjectModel.AddElement(E);
  E.AddAndUpdateRect(BR.ReadAreas);
  E.AddAndUpdateRect(BR.ReadLines);
  BR.Free;
end;
*)
(*
var
   aTool: TTool;
   Entity: TEntity;
   PZ: TRectEntity;
   i: longInt;
   IL: TLayerImportDialog;
begin
   aTool:= AddTool(TTopolImport.Create);
   if assigned(aTool) then
   begin
      aTool.Input := nil;
      aTool.DoIt;
      if aTool.output = nil then exit;
      try
         Entity := TEntity(aTool.OutPut);
         PZ := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
         if assigned(PZ) then
         begin
            for i := 0 to Entity.Count -1 do
            begin
               PZ.AddAndUpdateRect(Entity.Elements[i]);
               Entity.RemoveElement(Entity.Elements[i]);
            end;
            aTool.OutPut.Free;
            aTool.OutPut := nil;
         end
         else
         begin
            PZ := TRectEntity(aTool.OutPut);
            TEntity(World.ObjectModel).AddElement(PZ);
         end;
         if PZ <> nil then
         begin
            MainForm.MainMenu.Items[1].Visible := true;
            MainForm.MainMenu.Items[2].Visible := true;
         end;
      except
      end;
   end;
   Handled := true;
end;
*)

procedure  TMainTool.on_tm_SelectDataDirectory(var Handled: boolean);
//var
   //DD: TF_SelectDir;
begin
(*
   Handled := true;
   Application.CreateForm(TF_SelectDir, DD);
   try
     DD.Directory.Directory:= Options.DataDirectory;
     if DD.ShowModal = mrOK then
     begin
        Options.DataDirectory := DD.Directory.Directory;
     end;
   except
     on E:Exception do
     begin
       ShowMessage(E.Message + ': ' + Options.DataDirectory);
       Screen.Cursor:= crDefault;
       Options.DataDirectory:= ''
     end;
   end;
   DD.Free;
*)
end;





procedure  TMainTool.On_tm_AddView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
end;
{
var
   RE: TRectEntity;
   Tool: TFormToolManager;
   ISC: TInterpretScript;
   TIS: TUniversalTopolScriptCreator;
begin
   Tool := TFormToolManager.Create;
   TIS := TUniversalTopolScriptCreator.Create;
   TIS.DoIt;
   ISC := TInterpretScript(TIS.Output);
   Tool.InterpretScript := ISC;
   TIS.Free;
   if aMessage.Data = nil then
   begin
      (*
      RE := TRectEntity(TEntity(World.ObjectModel).FindElementClass(TTopolPredmetZajmu));
      *)
      RE := nil;
      Tool.Device.Page.Color := clWhite;
   end
   else
   begin
      RE := TRectEntity(aMessage.Data);
      Tool.Device.Page.Color := clSilver;
   end;
   Tool.Input := RE;
   AddTool(Tool);
   Tool.DoIt;
end;
}


procedure  TMainTool.On_tm_Explore(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;


procedure  TMainTool.On_tm_ExploreOwners(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TExplorer;
begin
    aTool := TExplorer.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.ShowOwners := true;
      aTool.Caption := 'Model vlastnk';
      aTool.DoIt
    end;
end;

procedure  TMainTool.On_tm_EditElement(var aMessage: TOrbisMessage; var Handled: boolean);
var
   aTool: TObjectPropertyEditor;
begin
    aTool := TObjectPropertyEditor.Create;
    AddTool(aTool);
    if assigned(aTool) then
    begin
      aTool.Input:= aMessage.Data;
      aTool.DoIt
    end;
end;



procedure  TMainTool.On_tm_ShowText(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  {
  if aMessage is TOrbisTextMessage then
     MainForm.StatusBar.SimpleText := TOrbisTextMessage(aMessage).Text;
  }
  Handled:= true
end;




procedure  TMainTool.On_tm_SetPalette(var Handled: boolean);
begin
  NastavBarvicky
end;






procedure TMainTool.On_tm_EndOfDDEScript;
begin
   ScriptReading := false;
   //CommandLine := nil;
   //MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS ukonil zpracovn DDE Scriptu';
end;


procedure TMainTool.On_tm_SetDDEResult;
begin
   //F_StartForm.DDEServerItem.Text := CommandLine.ResultLine;
end;



procedure   TMainTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
//var
   //PZ: TRectEntity;
   //Element: TElement;
begin
  {
  MainForm.Ed.Text:= intToStr(memAvail-MainForm.OrigMem);
  }
   Handled:= false; { vse se vyresi na miste }
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
     { SOUBOR }
      tm_NewProject:  on_tm_NewProject(aMessage,Handled);
      tm_OpenProject: on_tm_OpenProject(Handled);
      tm_SaveProject: on_tm_SaveProject(Handled);
      tm_SaveProjectAs: on_tm_SaveProjectAs(Handled);
      tm_ImportBlk:   on_tm_ImportBlk(Handled);
      tm_Import:     on_tm_Import(Handled);
      tm_Export:     on_tm_Export(aMessage, Handled);
      tm_Editor:     on_tm_Editor(Handled);
      tm_ModelChanged:  on_tm_ModelChanged(Handled);
      tm_SelectDataDirectory: on_tm_SelectDataDirectory(Handled);
      tm_ClearModel:;
      tm_SetOptions:  on_tm_SetOptions(Handled);
      tm_SetUpProject:  on_tm_SetUpProject(Handled);
      tm_ProjectManager:  on_tm_ProjectManager(Handled);
      tm_ZeroActivity:    TimeToAutoSave := true;
      //tm_DataSet:     on_tm_DataSet(Handled);
      //tm_ControlSet:  on_tm_ControlSet(Handled);
      //tm_Run:         on_tm_Run(Handled);
     { Mapov list }
      //tm_MapSheetList: PostMsg(tm_View, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);

     { Mapov list }
      tm_MapSheetList: PostMsg(tm_Explore, Self, TEntity(World.ObjectModel).FindElementClass(TMapSheets), DontKill);



     { ZOBRAZOVANI }
      tm_AddView: On_tm_AddView(aMessage, Handled);
      tm_Explore: On_tm_Explore(aMessage, Handled);
      tm_EditElement: On_tm_EditElement(aMessage, Handled);
      tm_ExploreOwners: On_tm_ExploreOwners(aMessage, Handled);
{      tm_About: On_tm_About(Handled); }
      tm_SetPalette: On_tm_SetPalette(Handled);
      tm_OIL              : on_tm_OIL(aMessage,Handled);

      tm_EndOfDDEScript   : on_tm_EndOfDDEScript;
      tm_SetDDEResult     : on_tm_SetDDEResult;
      tm_ShowText         : On_tm_ShowText(aMessage,Handled);
      tm_Run              : on_tm_Run(aMessage,Handled);
      tm_Param            : on_tm_Param(aMessage,Handled);
      tm_Intro            : on_tm_Intro;
      tm_FileBeforeLoad   : on_tm_FileBeforeLoad(aMessage,Handled);
      tm_FileAfterSave    : on_tm_FileAfterSave(aMessage,Handled);
      tm_FileExists       : on_tm_FileExists(aMessage,Handled);
      tm_FileDelete       : on_tm_FileDelete(aMessage,Handled);
   end;
end;

procedure  TMainTool.ExecuteMacro(M: TStrings);
begin
(*
   if M.Count < 1 then exit;
   if ScriptReading then
   begin
      if UpperCase(BezVnejsichMezer(M.Strings[0])) = c_END then on_tm_EndOfDDEScript
      else
      begin
         CommandLine.Line := '';
         CommandLine.Lines.Clear;
         CommandLine.Lines.Assign(M);
         CommandLine.DoIt;
         PostMsg(tm_SetDDEResult, Self, nil, DontKill);
      end;
   end
   else
   if UpperCase(M.Strings[0]) = c_Script then
   begin
      ScriptReading := true;
      MainForm.StatusBar.Panels.Items[0].Text := 'ORBIS zpracovv DDE Script';
   end;
*)
end;


function  TMainTool.GetText: string;
begin
   result := '';
   {
   result := MainForm.StatusBar.SimpleText;
   }
end;

procedure TMainTool.SetText(const aValue: string);
begin
   //MainForm.StatusBar.SimpleText := aValue;
end;



procedure  TMainTool.AddWorkTools;
begin
//  AddTool(TDeskTopSaveToText.Create);
//  AddTool(TViewScriptEditor.Create);
end;








procedure TMainTool.SetActualAction(const Value: integer);
begin
   FActualAction := Value;
   if FActualAction > 4 then FActualAction := 4;
end;

procedure TMainTool.SetActualActionCaption(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Caption := Value;
end;

procedure TMainTool.SetActualActionImageIndex(const Value: integer);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex := Value;
end;

procedure TMainTool.SetActualActionScript(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Category := Value;
end;

procedure TMainTool.SetActualActionVisible(const Value: boolean);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Visible := Value;
end;

procedure TMainTool.SetButtonCount(const Value: integer);
begin
end;

procedure TMainTool.SetNewImage(const Value: string);
var
   BM: Graphics.TBitmap;
   S: string;
begin
   {
   BM := Graphics.TBitmap.Create;
   S := '';
   if pos(':',Value) = 0 then
   begin
      S := ExePath;
      CheckBackSlash(S);
   end;
   S := S + Value;
   try
      BM.LoadFromFile(S);
   except
   end;
   MainForm.ImageList.AddMasked(BM,clGray);
   }
end;

procedure TMainTool.on_tm_Run(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S,SS: string;
begin
   Handled := true;
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   ScriptSender := aMessage.Sender;
   ExecuteScript := S;
   ScriptSender := nil;
end;

function TMainTool.GetActualActionCaption: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Caption;
end;

function TMainTool.GetActualActionImageIndex: integer;
begin
   result := 0;
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).ImageIndex;
end;

function TMainTool.GetActualActionScript: string;
begin
   result := '';
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Category;
end;

function TMainTool.GetActualActionVisible: boolean;
begin
   result := false;
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Visible;
end;

function TMainTool.GetActualActionHint: string;
begin
   //result := TAction(MainForm.ActionList.Actions[ActualAction]).Hint;
end;

procedure TMainTool.setActualActionHint(const Value: string);
begin
   //TAction(MainForm.ActionList.Actions[ActualAction]).Hint := Value;
end;

procedure TMainTool.SetShowActionsCaptions(const Value: boolean);
begin
{
   MainForm.ToolBar.ShowCaptions := Value;
   MainForm.ToolBar.ButtonHeight := 50;
   MainForm.ToolBar.ButtonWidth := 50;
}
end;

function TMainTool.GetImageHeight: integer;
begin
   result := 0;
   //result := MainForm.ImageList.Height;
end;

function TMainTool.GetImageWidth: integer;
begin
   result := 0;
   //result := MainForm.ImageList.Width;
end;

procedure TMainTool.SetImageHeight(const Value: integer);
begin
   //MainForm.ImageList.Height := Value;
end;

procedure TMainTool.SetImageWidth(const Value: integer);
begin
   //MainForm.ImageList.Width := Value;
end;

procedure TMainTool.On_tm_OIL(var aMessage: TOrbisMessage;
  var Handled: boolean);
{$IFNDEF WIN64}
var
   CMD: TCommandLineDlg;
   El: TElement;
{$ENDIF}
begin
{$IFNDEF WIN64}
   CMD := TCommandLineDlg.Create(Application);
   El := aMessage.Data;
   if El = nil then El := World;
   CMD.E := El;
   CMD.Show;
{$ENDIF}
end;

procedure TMainTool.RunStartScripts;
var
  OIL: string;
  S,SS: string;
begin
  Text := 'Kontrola Parametr';
  OIL:= GetParamWithExt('.OIL');
  if (OIL <> '') and fileExists(OIL) then
  begin
     ExecuteScript := OIL;
  end
  else
  begin
     if Options.StartScript <> '' then
        ExecuteScript := Options.StartScript;
  end;
  S := ScriptDirectory;
  CheckBackSlash(S);
  Text := 'Inicializace registru ORBIS';
  SS := GetAbsolutePath(S + 'SysReg.Oil');
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else ExecuteScript := SS;
  SS := GetAbsolutePath(S + 'Model.Oil');
  if not FileExists(SS) then
  begin
     ShowMessage('Nelze nalzt soubor '+SS);
  end
  else
  begin
     ExecuteScript := SS;
     if Assigned(FOnNewModelEvent) then
        OnNewModelEvent;
  end;
  LoadMaps;
end;

procedure TMainTool.On_tm_SaveProject(var Handled: boolean);
begin
   SaveProjectData;
end;

procedure TMainTool.On_tm_SaveProjectAs(var Handled: boolean);
var
   S: string;
begin
   {
   if Project = nil then exit;
   MainForm.SaveDialog.InitialDir := Options.ProjectDirectory;
   if not MainForm.SaveDialog.Execute then exit;
   SaveMaps;
   SaveProjectionInfo;
   S := ExtractFileName(MainForm.SaveDialog.FileName);
   S := ChangeFileExt(S,'');
   Project.Name := S;
   Options.ProjectFile := MainForm.SaveDialog.FileName;
   MainForm.Caption := CaptionString + Project.Name;
   SaveProjectData;
   //ShowMessage(S);
   }
end;

procedure TMainTool.ViewProjectIntroDialog;
var
   D: TProjectIntroDialog;
begin
   D := TProjectIntroDialog.Create;
   D.LastProjectName := Options.ProjectFile;
   D.DoIt;
   case D.Result of
      1:  PostMsg(tm_NewProject,Self,nil,false);
      2:  PostMsg(tm_OpenProject,Self,nil,false);
      3:  OpenLastProject;
   end;
   if D.DontViewDialog then Options.DontViewProjectIntroDialog := true
                       else Options.DontViewProjectIntroDialog := false;
   if D.OpenLastProject then Options.AutoOpenLastProject := true
                        else Options.AutoOpenLastProject := false;
   D.Free;
end;

procedure TMainTool.OpenLastProject;
begin
   LoadProjectFromFile(Options.ProjectFile);
end;

procedure TMainTool.SetProject(const Value: TORBISLHCProject);
begin
   ExChangeFieldElement(TElement(FProject),Value);
   {
   if Value <> nil then
   begin
      MainForm.Caption := CaptionString + Value.Name;
      MainForm.a_SaveProject.Enabled := true;
      MainForm.a_SaveProjectAs.Enabled := true;
   end;
   }
end;

procedure TMainTool.on_tm_Intro;
begin
   {
   if not Options.DontViewProjectIntroDialog then
      ViewProjectIntroDialog
   else if Options.AutoOpenLastProject then OpenLastProject;
   if Options.EditorOn then
   begin
      PostMsg(tm_Editor,Self,nil, false);
   end;
   }
end;


procedure TMainTool.CreateNewDATA;
var
   S,SS: string;
   E: TEntity;
   Maps: TThematicMaps;
begin
   ProgressText := 'Ruen stvajcch dat...';
   Application.ProcessMessages;
   E := TEntity(World.ObjectModel.FindElementName('DATA'));
   E.FreeAll();
   Maps := tThematicMaps(World.ObjectModel.FindElementName('MAPS'));
   Maps.Clear;
   ProgressText := 'Vytven struktury novch dat ...';
   Application.ProcessMessages;
   S := ScriptDirectory;
   CheckBackSlash(S);
   SS := S + 'DATA.Oil';
   ExecuteScript := SS;
   //LoadMaps;
   //LoadProjects;
   ProgressText := 'Struktura novch dat zdrn vytvoena';
   //LoadZnDBF;
   Application.ProcessMessages;
   if Assigned(FOnNewDATAEvent) then
      OnNewDATAEvent;
end;

procedure TMainTool.CreateNewModel;
var
   S,SS: string;
   E: TEntity;
begin
   ProgressText := 'Ruen stvajcho modelu...';
   Application.ProcessMessages;
   E := World.ObjectModel;
   NextElement := E;
   World.ObjectModel := nil;
   E.Free();
   ProgressText := 'Vytven struktury novho  modelu...';
   Application.ProcessMessages;
   S := ScriptDirectory;
   CheckBackSlash(S);
   SS := S + 'Model.Oil';
   ExecuteScript := SS;
   LoadMaps;
   LoadProjects;
   LoadRasters;
   LoadKatastrs;
   LoadUserLayers;
   ProgressText := 'Struktura novho modelu zdrn vytvoena';
   //LoadZnDBF;
   Application.ProcessMessages;
   if Assigned(FOnNewModelEvent) then
      OnNewModelEvent;
end;

procedure TMainTool.ImportData;
begin
   ProgressText := 'Probh import externch dat ...';
   Application.ProcessMessages;
   ExecuteScript := Options.ImportScript;
   Project.Modified := true;
   Project.LastChangesExported := true;
end;

procedure TMainTool.on_tm_SetUpProject(var Handled: boolean);
var
   D: TLHCProjectDialog;
   S,S1: string;
begin
   if Project = nil then exit;
   D := TLHCProjectDialog.Create;
   D.ProjectDirectory := Options.ProjectDirectory;
   D.Input := Project;
   S := Project.ExternalDataDirectory;
   S1 := Project.ExternalDataDirectory;
   D.DoIt;
   SaveProject;
end;

procedure TMainTool.On_tm_Export(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S: string;
   S1,S2: string;
begin
   NoAutoSave := true;
   Handled:= true;
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   if StringAsTwoParams(S,'&',S1,S2) then
      S := S1+S2;
   ExecuteScript := Options.GetPropertyStringByName(S+'Script');
   NoAutoSave := false;
end;

procedure TMainTool.on_tm_FileAfterSave(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S: string;
begin
   if No_FileEvents then exit;

   if Assigned(On_FileAfterSaveEvent) then
   begin
      if not (aMessage is TOrbisTextMessage) then exit;
      S := TOrbisTextMessage(aMessage).Text;
      On_FileAfterSaveEvent(S);
   end;
end;

procedure TMainTool.on_tm_FileBeforeLoad(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S: string;
begin
   if No_FileEvents then exit;
   if Assigned(On_FileBeforeLoadEvent) then
   begin
      if not (aMessage is TOrbisTextMessage) then exit;
      S := TOrbisTextMessage(aMessage).Text;
      On_FileBeforeLoadEvent(S);
   end;
end;

procedure TMainTool.on_tm_FileDelete(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S: string;
begin
   if No_FileEvents then exit;
   if Assigned(On_FileDeleteEvent) then
   begin
      if not (aMessage is TOrbisTextMessage) then exit;
      S := TOrbisTextMessage(aMessage).Text;
      On_FileDeleteEvent(S);
   end;
end;

procedure TMainTool.on_tm_FileExists(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S: string;
begin
   if No_FileEvents then exit;
   if Assigned(On_FileExistsEvent) then
   begin
      if not (aMessage is TOrbisTextMessage) then exit;
      S := TOrbisTextMessage(aMessage).Text;
      On_FileExistsEvent(S);
   end;
end;

procedure TMainTool.On_tm_Import(var Handled: boolean);
var
   D: TLHCImportDialog;
   e: TElement;
   S,SS: string;
   Projects: TOrbis01Projects;
begin
   if Project = nil then
   begin
      ShowMessage('Nen inicializovn dn projekt!');
      exit;
   end;
   NoAutoSave := true;
   Application.ProcessMessages;
   StartProgress('Import',0,0);

   S :='Probh import externch dat ';
   ProgressText := S;
   Application.ProcessMessages;
   if Project.Comment = 'XML' then
      ExecuteScript := Options.ImportXMLScript
   else
   if Project.Comment = 'ORB3' then
      ExecuteScript := 'GORBIS\ImportORB3.oil'
   else
      ExecuteScript := Options.ImportScript;
   {
   case D.Result of
       1:
       begin
          if D.SkupinyParcel then
          begin
             ProgressText := S+'Skupin parcel ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportSkupinParcelScript;
          end;
          if D.Parcely then
          begin
             ProgressText := S+'Parcel ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportParcelScript;
          end;
          if D.Rev then
          begin
             ProgressText := S+'Revry ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportRevScript;
          end;
          if D.ZAK then
          begin
             ProgressText := S+'ZAK ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportZAKScript;
          end;
          if D.DET then
          begin
             ProgressText := S+'DET ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportDETScript;
          end;
          if D.DETLines then
          begin
             ProgressText := S+'DETovch lini ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportDETLinesScript;
          end;
          if D.SLU then
          begin
             ProgressText := S+'SLU ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportSLUScript;
          end;
          if D.SRF then
          begin
             ProgressText := S+'SLU ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportSRFScript;
          end;
          if D.TEZ then
          begin
             ProgressText := S+'TEZ ...';
             Application.ProcessMessages;
             ExecuteScript := Options.ImportTEZScript;
          end;
       end;
   end;
   D.Free;
   }
   //Project.Modified := true;
   //Project.LastChangesExported := true;

   EndProgress;
   {
   if not Confirm('Vechna dosavadn data projektu pjdou asi do hje ... pokraovat ?') then
      exit;
   CreateNewModel;
   ImportData;
   SetEditorData;
   }
   SetEditorData;
   Application.ProcessMessages;
   Application.ProcessMessages;
   //SaveProjectData;   presunuje se az za nastaveni nazvu projektu
   e := World.ObjectModel.FindElementName('PROJECTS');
   Projects := TOrbis01Projects(e);
   Projects.AddProject(Project,S,NewUserDataSplitted,DataProfileName);
   // ulozeni projektu se odehraje zde ... je nastaven nazev podle LHC
   //-------------------------------------------
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   S := S+Project.Name+'.OPR';
   S := GetAbsolutePath(S);
   SaveData(Project,S);
   Options.ProjectFile := S;
   //-------------------------------------------
   //if S <> '' then
   //begin
   //   DeleteProject(S);
   //end;
   SaveProjectData;   //presunuje se az za nastaveni nazvu projektu
   SaveProjects;
   CHeckProjectRasters;
   CheckProjectVRS;
   CheckProjectTYP;
   CHeckDataProfile;
   NoAutoSave := false;
end;
(*
var
  BR: TTopoLBlokReader;
  E: TRectEntity;
  DD: TLayerImportDialog;
  MSC: TModelScriptCreator;
  MBSC: TModelByScriptCreator;
begin

   DD := TLayerImportDialog.Create;
   MSC := TModelScriptCreator.Create;
   MBSC := TModelByScriptCreator.Create;
   try
      DD.InitialDir := Options.DataDirectory;
      DD.DoIt;
      MSC.Input := DD.Output;
      MSC.DataDirectory := Options.DataDirectory;
      MSC.DoIt;
      MBSC.Input := MSC.Output;
      MBSC.DoIt;
      MBSC.Output.Name := 'DATA';
      World.ObjectModel.AddElement(MBSC.Output);
   except
   end;
   DD.Free;
   MSC.Free;
   MBSC.Free;
end;
*)



procedure TMainTool.LoadProjectFromFile(aFile: string);
var
   Load: TLoad;
   NewProject: TORBISLHCProject;
   Imp: boolean;
begin
   if (aFile <> Options.ProjectFile) or (Project = nil) then
   begin
      StartProgress('Otevrn projektu: '+ aFile,0,0);
      ProgressText := 'ten projektovho souboru ...';
      Application.ProcessMessages;
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,aFile,nil);
   Application.ProcessMessages;
{$ENDIF}
      Load := TLoad.Create;
      Load.FileName := GetabsolutePath(aFile);
      try
         Load.DoIt;
      except
         on E: Exception do
         begin
            ShowMessage(E.Message);
            Load.Free;
            EndProgress;
            exit;
         end;
      end;
      // osetreni pomoci exception ... tady nejak chybi
      NewProject := TORBISLHCProject(Load.Output);
      Load.Free;
      ProgressText := 'Kontrola uloen pvodnho projektu ...';
      Application.ProcessMessages;
      CheckProjectForSave;
      //CheckUserDataForSave; // novinka
      Project := NewProject;
      UserDataSplitted := NextUserDataSplitted;
      Options.ProjectFile := aFile;
      //CreateNewModel;
      CreateNewDATA;
      NewProject.DataDirectory := ExtractFilePath(aFile);
      Imp := false;
      if Project.DataFileExists then
      begin
         LoadProjectData;
      end
      else
      begin
         if Confirm('Projekt: '+Project.Name,
          'Projekt neobsahuje dosud dn data, pejete si je nyn naimportovat ?') = 1 then
         begin
            imp := true;
         end;
      end;
      CheckModelVersion;
      CheckLHCYear(0, 0, false); // Values are in Chk_LHC_Attr   ... maybe

      //LoadProjectionInfo;
      //LoadMaps;
      LoadProjects;
      LoadUserDataCheckSplit; // novinka
      CHeckProjectRasters;
      CheckProjectVRS;
      CheckProjectTYP;
      SetEditorData;
      EndProgress;
      if Imp then
         PostMsg(tm_Import,nil,nil,false);
   end;
end;

procedure TMainTool.CheckProjectForSave;
begin
   // zmena pro komponentu
   CheckUserDataForSave;
   exit;
   {
   if Editor <> nil then
      Editor.UpdateModel;
   SaveEditorModelFile;
   SaveMaps;
   if Project = nil then exit;
   SaveProjectionInfo;
   if Project.Modified then
   begin
      if Confirm('Projekt '+ Project.Name + ' zmnn - pejete si ho uloit ?') then
      begin
         SaveProjectData;
      end;
   end;
   }
end;

procedure TMainTool.LoadProjectData;
var
   Load: TLoad;
   E: TElement;
   Restore: boolean;
   S,S1,S2: string;
begin
   Restore := false;
   ProgressText := 'ten datovho souboru ...';
   Application.ProcessMessages;
   E := World.ObjectModel.FindElementName('DATA');
   Load := TLoad.Create;
   Load.FileName := Project.DataFileName;
   try
      Load.DoIt;
      E.Free;
      World.ObjectModel.NextElement := TObjectModel(Load.output);
   except
      if Confirm('Pi natn dat Projektu dolo k Chyb, pejete si obnovu ze zlon souboru?(ANO) Osobn bych doporuoval ukonit aplikaci a zkusit naten znovu (NE,STORNO)') then
         Restore := true;
   end;
   Load.Free;
   if not Restore then exit;
   S := Project.DataFileName;
   S1 := ChangeFileExt(S,'.OR_');
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S1,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(S1) then
   begin
      ShowMessage('Je to smutn, ale zlon soubor neexistuje! Bh ehnej GISu.');
      exit;
   end;
   S2 := ChangeFileExt(S,'.OR1');
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S2,nil);
   Application.ProcessMessages;
{$ENDIF}
   if FileExists(S2) then DeleteFile(PChar(S2));
   RenameFile(S,S2);
   RenameFile(S1,S);
   RenameFile(S2,S1);
   ProgressText := 'ten zlonho datovho souboru ...';
   Application.ProcessMessages;
   E := World.ObjectModel.FindElementName('DATA');
   Load := TLoad.Create;
   Load.FileName := Project.DataFileName;
   try
      Load.DoIt;
      if E <> nil then
         E.Free;
      World.ObjectModel.NextElement := TObjectModel(Load.output);
   except
      if Confirm('I pi natn dat Projektu ze zlohy dolo k Chyb, soubory budou vrceny do pvodnho stavu bez ohledu na Vai odpov. Obrate se s dvrou na autory programu, nadje umr posledn.') then;
      RenameFile(S,S2);
      RenameFile(S1,S);
      RenameFile(S2,S1);
   end;
   Load.Free;
end;

function TMainTool.LoadProjectDataFormORB(const aFileName, DataType: string): integer;
var
   S: string;
   isDATA: boolean;
begin
   IsDATA := DataType = 'DATA';
   SetParam('DataFromORB','true');
   SetParam('FileName',aFileName);
   SetParam('DataType',DataType);
   S := ScriptDirectory;
   CheckBackSlash(S);
   S := GetAbsolutePath(S + 'LoadProjectDataFromORB.oil');
   if isDATA then
      CheckProjectForSave;
   ExecuteScript := S;
   result := StrToIntDef(GetParam('Result'),0);
   if isDATA and (result = 1) then
   begin
      LoadProjects;
      LoadUserDataCheckSplit; // novinka
      CHeckProjectRasters;
      CheckProjectVRS;
      CheckProjectTYP;
   end;
   if DataType = 'VRS' then
      CheckProjectVRS;
   if DataType = 'TYP' then
      CheckProjectTYP;
   SetEditorData;
end;

procedure TMainTool.SaveProjectData;
var
   BackFileName,FileName: string;
   E: TElement;
begin
   FileName := GetAbsolutePath(Project.DataFileName);
   (*     @@@ppk Brno 29.7.2010 ?????????
   BackFileName := ChangeFileExt(FileName,'.OR_');
   if FileExists(BackFileName) then
      DeleteFile(PChar(BackFileName));
   RenameFile(FileName,BackFileName);
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileAfterSave,BackFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   *)
   E := World.ObjectModel.FindElementName('DATA');
   if E = nil then exit;
   SaveData(E,FileName);
   Project.Modified := false;
   Saveproject;
end;

procedure TMainTool.SaveProject;
begin
   SaveData(Project,  GetAbsolutePath(Options.ProjectFile));
end;

procedure TMainTool.SetCaptionString(const Value: string);
begin
   FCaptionString := Value;
end;

procedure TMainTool.On_tm_Editor(var Handled: boolean);
var
   GF: TGraphic_Form;
   G: TGraphicForm;
begin
   (*
   if Editor <> nil then
   begin
      Editor.UpdateModel;
      PostMsg(tm_QuitTask,Editor,nil,false);
      FEditor := nil;
      {
      MainForm.a_GraphicEditor.Checked := false;
      }
      Options.EditorOn := false;
   end
   else
   begin
      if not Options.NewEditor and (EditorModel = nil) then
         LoadEditorModelFile;
      Options.NewEditor := false;
      if EditorModel = nil then
         ExecuteScript := Options.EditorScript;
      if EditorModel = nil then
      begin
         ShowMessage('Chyba skriptu pro vytvoen Editoru!');
         exit;
      end;
      NewToolByModel := EditorModel;
      Application.ProcessMessages;
      //achry Machry...
      G := TGraphicForm(Editor.GetToolByName('GW'));
      GF := G.Form;
      //MainForm.MenuBar.ManualDock(GF.TopBar);
      G.Tasks.ToolBar.ManualFloat(Rect(100,200,132,132));
      G.TaskTools.ToolBar.ManualFloat(Rect(200,200,232,132));
      GF.LeftBar.Visible := false;
      GF.RightBar.Visible := false;
      GF.MenuBar1.Menu := MainForm.MainMenu1;
      MainForm.ControlBar1.Visible := false;
      MainForm.OnKeyDown := GF.FormKeyDown;
      GF.ManualDock(MainForm,nil,alClient);
      //Application.ProcessMessages;
      GF.Align := alClient;
      Application.ProcessMessages;
      Editor.Visible := true;
      Application.ProcessMessages;
      if Project = nil then
      begin
         World.SystemRegister.FreeElement(World.SystemRegister.FindElementName('Projection'));
         ExecuteScript := 'LED\ProjectionInfoModel.OIL';
      end;
      if Project <> nil then
         ExecuteScript := Options.EditorDataScript;
      MainForm.a_GraphicEditor.Checked := true;
      Options.EditorOn := true;
   end;
   *)
end;

function TMainTool.GetEditLayers: TEntity;
begin
   Result := TEntity(World.ObjectModel.FindElementName('UserLayers'));
end;

function TMainTool.GetEditor: TControlGroup;
begin
   result := nil;
   if FEditor = nil then
   begin
      FEditor := TControlGroup(GetToolByName('EDITOR'));
   end;
   result := FEditor;
end;

procedure TMainTool.SetEditor(const Value: TControlGroup);
begin
   ExchangeFieldTool(TTool(Feditor),Value);
end;

function TMainTool.GetEditorModel: TToolModel;
var
   E: Telement;
begin
   result := nil;
   E := World.SystemRegister.FindElementName('EDITOR');
   if not (E is TToolModel) then exit;
   result := TToolModel(E);
end;

procedure TMainTool.SetEditorData;
begin

   //if Editor <> nil then
      ExecuteScript := Options.EditorDataScript;
end;

procedure TMainTool.SetGeneralEvent(const Value: string);
var
   aID,aValue: string;
begin
   StringAsTwoParams(Value,'&',aID,aValue);
   if aID = '' then exit;
   if Assigned(OnGeneralEvent) then
      OnGeneralEvent(aID,aValue);
end;

procedure TMainTool.On_tm_ModelChanged(var Handled: boolean);
begin
   if Project <> nil then
      Project.Modified := true;
   ActualEditLayerChanged := true;
end;

function TMainTool.GetScriptDirectory: string;
var
   S: string;
begin
   S := Options.ScriptDirectory;
   CheckBackSlash(S);
   result := S;
end;

procedure TMainTool.LoadEditorModelFile;
var
   S: string;
   L: TLoad;
begin
   S := GetAbsolutePath('LEDEDITOR.ORB');
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(S) then
      exit;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.SystemRegister.NextElement := L.Output;
   L.Free;
end;

procedure TMainTool.SaveData(aData: TElement; aFileName: string);
var
   Save: TSave;
begin
   Save := TSave.Create;
   Save.FileName := aFileName;
   Save.Input := aData;
   Save.DoIt;
   Save.Free;
end;

procedure TMainTool.SaveEditorModelFile;
var
   FN: string;
begin
   if EditorModel = nil then exit;
   FN := GetAbsolutePath('LEDEDITOR.ORB');
   SaveData(EditorModel,FN);
end;

procedure TMainTool.CheckDataProfile;
var
   S,SS: string;
begin
     S := ScriptDirectory;
     CheckBackSlash(S);
     SS := GetAbsolutePath(S + 'DataProfileCheck.oil');
     if FileExists(SS) then
     begin
        ExecuteScript := SS;
     end;
end;

procedure TMainTool.CheckLHCYear(LHC_KOD, LHC_Year: integer; Setup: boolean);
var
   e: TElement;
   FM: Tgis_ForestModel;
begin
   if Setup then
   begin
      Chk_LHC_Attr.LHC_YEAR := LHC_Year;
      Chk_LHC_Attr.LHC_KOD := LHC_KOD;
      Chk_LHC_Attr.Check := true;
   end
   else
   begin
      if not Chk_LHC_Attr.Check then exit;
      if Chk_LHC_Attr.LHC_YEAR = 0 then  exit;
      e := World.ObjectModel.Element['DATA'];
      if e = nil then exit;
      e := TEntity(e).Element['LHC'];
      if e = nil then exit;
      FM := Tgis_ForestModel(e);
      FM.LHC_Cislo := Chk_LHC_Attr.LHC_KOD;
      if FM.ActualLHC <> nil then
      if FM.ActualLHC.ROK <> Chk_LHC_Attr.LHC_YEAR then
         FM.ActualLHC.ROK := Chk_LHC_Attr.LHC_YEAR;
      Chk_LHC_Attr.Check := false;  // Switch off because next possible checking
   end;
end;

procedure TMainTool.CheckModelVersion;
var
   S,SS: string;
begin
     S := ScriptDirectory;
     CheckBackSlash(S);
     SS := GetAbsolutePath(S + 'DataCheck.oil');
     if FileExists(SS) then
     begin
        ExecuteScript := SS;
     end;
end;

procedure TMainTool.SetModelVersion;
begin

end;

procedure TMainTool.LoadProjectionInfo;
var
   S: string;
   L: TLoad;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementClass(TProjectionInfoModel));
   S := ChangeFileExt(Options.ProjectFile,'.OPP');
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(S) then
   begin
      S := ScriptDirectory;
      CheckBackSlash(S);
      ExecuteScript := S+'ProjectionInfoModel.OIL';
      exit;
   end;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.ObjectModel.NextElement := L.Output;
   L.Free;
end;

procedure TMainTool.SaveProjectionInfo;
var
   S: string;
   E: TElement;
begin
   S := ChangeFileExt(Options.ProjectFile,'.OPP');
   E := World.ObjectModel.FindElementClass(TProjectionInfoModel);
   if E = nil then exit;
   SaveData(E,S);
end;

procedure TMainTool.LoadMaps;
var
   S: string;
   L: TLoad;
   E: TElement;
   ByScript: boolean;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('MAPS'));
   //ByScript := Project = nil;
   ByScript := false;
   if not ByScript then
   begin
      //S := ChangeFileExt(Options.ProjectFile,'.OMP');
      S := Options.StoreDirectory;
      CheckBackSlash(S);
      S := S + 'Maps.orb';
      S := GetAbsolutePath(S);
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
      ByScript := not FileExists(S);
   end;
   if ByScript then
   begin
      S := ScriptDirectory;
      CheckBackSlash(S);
      ExecuteScript := S+'Maps.OIL';
   end
   else
   begin
      L := TLoad.Create;
      L.FileName := S;
      L.DoIt;
      World.ObjectModel.NextElement := L.Output;
      L.Free;
   end;
   E := World.ObjectModel.FindElementName('MAPS');
   if not (E is TThematicMaps) then exit;
   TThematicMaps(E).Reset := True;
end;

procedure TMainTool.SaveMaps;
var
   S: string;
   E: TElement;
   M: TThematicMaps;
begin
   S := Options.StoreDirectory;
   CheckBackSlash(S);
   S := S + 'Maps.orb';
   S := GetAbsolutePath(S);
   E := World.ObjectModel.FindElementName('MAPS');
   if E = nil then exit;
   if not (E is TThematicMaps) then
   begin
      PostTextMsg(tm_AddToProtocol,'Project Error: Maps not found',nil);
      exit;
   end;
   M := TThematicMaps(E);
   M.Clear;
   SaveData(E,S);
   M.Reset := True;
end;

procedure TMainTool.on_tm_Param(var aMessage: TOrbisMessage; var Handled: boolean);
var
   S,S1,S2: string;
begin
   Handled := true;
   if not (aMessage is TOrbisTextMessage) then exit;
   S := TOrbisTextMessage(aMessage).Text;
   if StringAsParameter(S,S1,S2) then
      SetParam(S1,S2);
end;

procedure TMainTool.on_tm_ProjectManager(var Handled: boolean);
var
   M: TLHCProjectManager;
begin
   M := TLHCProjectManager.Create;
   M.Caption := 'Stav projektu:'+Project.Name;
   M.DoIt;
   M.Free;
end;

procedure TMainTool.LoadZnDBF;
var
   S: string;
   L: TLoad;
begin
   {
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('Znacky_DBF'));
   S := ExePath+'LED\Zn.orb';
   if not FileExists(S) then
   begin
      ShowMessage('Soubor druh '+S+' neexistuje! (co je asi chyba)');
      exit;
   end;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   World.ObjectModel.NextElement := L.Output;
   L.Free;
   }
end;

function TMainTool.GetProjectChanged: boolean;
begin
   result := false;
   if Project <> nil then
      result := Project.Modified;
   ActualEditLayerChanged := true;
end;

function TMainTool.GetProjectDataDirectoryEx: string;
var
   e: TElement;
   L: Tgis_LHC;
   LI: integer;
   LR: integer;
   S: string;
   LIF: TOrbis01LHCInfo;
begin
   result := '';
   if Continual then
   begin
      e := World.ObjectModel.Element['CONT'];
      if e = nil then exit;
      e := TEntity(e).Element['ActiveLHC'];
      if e = nil then exit;
      LIF := TOrbis01LHCInfo(TEntity(e).FindElementClass(TOrbis01LHCInfo));
      if LIF = nil then exit;
      LI := LIF.LHCNumber;
      LR := LIF.LHCYear;
   end
   else
   begin
      e := World.ObjectModel.Element['DATA'];
      if e = nil then exit;
      e := TEntity(e).Element['LHC'];
      if e = nil then exit;
      L := Tgis_LHC(TEntity(e).FindElementClass(Tgis_LHC));
      if L = nil then exit;
      LI := L.Cislo;
      LR := L.ROK;
   end;
   result := 'DATAEX' + PathDelim + IntToStr(LI) + '_' + IntToStr(LR);
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   result := S + result;
   result := GetAbsolutePath(result);
end;

procedure TMainTool.SetProjectChanged(const Value: boolean);
begin
   if Project <> nil then
      Project.Modified := Value;
end;

procedure TMainTool.SetTimeToAutoSave(const Value: boolean);
begin
   {
   if not ProjectChanged then
   begin
      AutoSaveNeeded := false;
      exit;
   end;
   if NoAutoSave then
   begin
      AutoSaveNeeded := true;
      exit;
   end;
   AutoSaveNeeded := false;
   if not ReadyForZeroActivity then exit;
   MainForm.Timer.Enabled := false;
   Application.ProcessMessages;
   SaveProjectData;
   MainForm.Timer.Enabled := true;
   EndZeroActivity;
   }
end;

procedure TMainTool.SetUpAutoSave;
begin
   {
   MainForm.Timer.Interval := Options.AutoSaveInterval*60000;
   MainForm.Timer.Enabled := Options.AutoSave;
   }
end;

procedure TMainTool.SetNoAutoSave(const Value: boolean);
begin
   FNoAutoSave := Value;
   if not Value and AutoSaveNeeded then
      TimeToAutoSave := true;
end;

procedure TMainTool.SetAutoSaveNeeded(const Value: boolean);
begin
   FAutoSaveNeeded := Value;
end;


procedure TMainTool.ReadIniFile;
begin
   ReadParamsFromIni;
end;

procedure TMainTool.LoadplugIns;
begin

end;

procedure TMainTool.LoadProjects;
var
   S: string;
   L: TLoad;
   E: TElement;
   ByScript: boolean;
begin
   World.ObjectModel.FreeElement(World.ObjectModel.FindElementName('PROJECTS'));
   ByScript := false;
   if not ByScript then
   begin
      //S := ChangeFileExt(Options.ProjectFile,'.OMP');
      S := Options.StoreDirectory;
      CheckBackSlash(S);
      S := S + 'PROJECTS.orb';
      S := GetAbsolutePath(S);
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
      ByScript := not FileExists(S);
   end;
   if ByScript then
   begin
      S := ScriptDirectory;
      CheckBackSlash(S);
      ExecuteScript := S+'Projects.OIL';
   end
   else
   begin
      L := TLoad.Create;
      L.FileName := S;
      L.DoIt;
      World.ObjectModel.NextElement := L.Output;
      L.Free;
   end;
end;

procedure TMainTool.SaveProjects;
var
   S: string;
   E: TElement;
begin
   S := Options.StoreDirectory;
   CheckBackSlash(S);
   S := S + 'PROJECTS.orb';
   S := GetAbsolutePath(S);
   E := World.ObjectModel.FindElementName('PROJECTS');
   if E = nil then exit;
   SaveData(E,S);
end;

function TMainTool.JoinProjects(aSourcePath: string): integer;
var
   Projects, SourceProjects: TOrbis01Projects;
   LI,LI1: TOrbis01LHCInfo;
   SourceProject: TOrbisLHCProject;
   LHCI,LHCR: integer;
   S,SS,ProjectName: string;
   aTargetPath: string;
   L: TLoad;
   i: integer;
begin
   result := 0;
   if not DirectoryExists(aSourcePath) then // blb cesta ke zdroji
   begin
      result := 5;
      exit;
   end;
   Projects := TOrbis01Projects(World.ObjectModel.FindElementName('PROJECTS'));
   CheckBackSlash(aSourcePath);
   S := aSourcePath + 'PROJECTS.orb';
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
   if (Projects = nil) or not FileExists(S) then // Zdrojov nebo clov projekty jsou v hji
   begin
      result := 4;
      exit;
   end;
   // Nacteni projektu
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   SourceProjects := TOrbis01Projects(L.Output);
   World.ObjectModel.NextElement := SourceProjects;
   L.Free;
   if SourceProjects = nil then
   begin
      result := 4;
      exit;
   end;
   if not SourceProjects.LHCs.NoElements then
   for i := SourceProjects.LHCs.LastIndex downto 0 do
   begin
      LI := TOrbis01LHCInfo(SourceProjects.LHCs.Elements[i]);
      S := aSourcePath + LI.ProjectName+'.opr';
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
      if not FileExists(S) then
         Continue;  // projekt neexistuje, jde se dal
      L := TLoad.Create;
      L.FileName := S;
      L.DoIt;
      SourceProject := TOrbisLHCProject(L.Output);
      World.ObjectModel.NextElement := SourceProject;
      L.Free;
      S := aSourcePath + LI.ProjectName+'.orb';
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
      if not FileExists(S) then
      begin
         result := 2;
         Continue;  // chybi datovy soubor
      end;
      //Zkontrolujeme, zda LHC uz existuje
      LHCI := LI.LHCNumber;
      LHCR := LI.LHCYear;
      LI1 := Projects.GetLHCInfo(LHCI,LHCR);
      if LI1 <> nil then    // LHC uz existovalo
      begin
         ProjectName := LI1.ProjectName;
         DeleteProject(ProjectName);
         LI1.Free;            // vyhodit stavajici zaznam
      end;
      ProjectName := 'LHP_'+IntToStr(LHCI)+'_'+IntToStr(LHCR);
      SourceProject.Name := ProjectName;
      SS := GetAbsolutePath(Options.ProjectDirectory);
      CheckBackSlash(SS);
      aTargetPath := SS;
      SS := aTargetPath + ProjectName + '.opr';
      S := aSourcePath + LI.ProjectName + '.opr';
      //RenameFile(S,SS);
      // ulozeni projektu s novym nazvem
      SaveData(SourceProject,SS);
      SourceProject.Free;
      DeleteFile(PCHar(S));
      SS := aTargetPath + ProjectName + '.orb';
      S := aSourcePath + LI.ProjectName + '.orb';
      RenameFile(S,SS);
      LI.ProjectName := ProjectName;
      Projects.LHCs.AddElement(LI);
   end;
   SourceProjects.Free;
   SaveProjects;
end;

procedure TMainTool.DeleteProject(aProjectName: string);
var
   S,S1: string;
begin
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   S := S+aProjectName;
   S := GetAbsolutePath(S);
   S1 := S+'.opr';
   if FileExists(S1) then
      DeleteFile(PChar(S1));
   S1 := S+'.orb';
   if FileExists(S1) then
      DeleteFile(PChar(S1));
   S1 := S+'.or_';
   if FileExists(S1) then
      DeleteFile(PChar(S1));
end;

function TMainTool.DeleteUserLayer(LHC_KOD, LHC_Year: integer; aLayerName: string; LHC_Splitted: boolean): boolean;
var
   aFileName, S: string;
   UData: TEntity;
   Lay: TEntity;
   el: TElement;
   i: integer;
begin
   result := false;
   if LHC_Splitted then
   begin
      // ruseni souboru vrstvy
      aFileName := 'UDSL_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+'_' + aLayerName + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
      DelFil(aFileName);
      // a seznam vrstev
      aFileName := 'UDSL_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+'_' + aLayerName + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end
   else
   begin
      aFileName := 'USERDATA_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+ '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end;
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,aFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(aFileName) then exit;
   result := true;
   UData := TEntity(_Load(aFileName));
   if LHC_Splitted then
   begin
      Lay := TEntity(UData.FindElementName(aLayerName));
      UData.FreeElement(Lay);
   end
   else
   begin
      for i := UData.LastIndex  downto 0 do
      begin
         el := Udata.Elements[i];
         if EndsText('_' + aLayerName,el.Name) then
            UData.FreeElement(el);
      end;
   end;
   _Save(UData, aFileName); // aftersave by melo byt vobsazeno ve tride save
   UData.Free;
end;

function TMainTool.DeleteUserPhysicalLayer(LHC_KOD, LHC_Year: integer; aLayerName, aLayerType: string; LHC_Splitted: boolean): boolean;
var
   aFileName, S: string;
   UData: TEntity;
   Lay: TEntity;
begin
   result := false;
   if LHC_Splitted then
   begin
      aFileName := 'UDSL_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+'_' + aLayerName + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end
   else
   begin
      aFileName := 'USERDATA_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+ '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end;
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,aFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(aFileName) then exit;
   result := true;
   UData := TEntity(_Load(aFileName));
   Lay := TEntity(UData.FindElementName(aLayerType + '_' + aLayerName));
   if Lay <> nil then
   begin
      UData.FreeElement(Lay);
      _Save(UData, aFileName); // aftersave by melo byt vobsazeno ve tride save
   end;
   UData.Free;
end;

procedure TMainTool.DelFil(aFileName: string);
begin
   {$IFDEF FILEEVENT}
      PostTextMsg(tm_FileExists,aFileName,nil);
      Application.ProcessMessages;
   {$ENDIF}
   if FileExists(aFileName) then
   begin
      SysUtils.DeleteFile(aFileName);
     {$IFDEF FILEEVENT}
        PostTextMsg(tm_FileDelete,aFileName,nil);
        Application.ProcessMessages;
     {$ENDIF}
   end;
end;

function TMainTool.FindProjectName: string;
var
   P: TORBISLHCProject;
   S,S1,S3: string;
   i: integer;
begin
   S := GetAbsolutePath(Options.ProjectDirectory);
   CheckBackSlash(S);
   S1 := 'LHP';
   S3 := '';
   if FileExists(S + S1 + '.OPR') then
   begin
      i := 1;
      S3 := IntToStr(i);
      while FileExists(S + S1 + S3 + '.OPR') do
      begin
         Inc(i);
         S3 := IntToStr(i);
      end;
   end;
   result := (S1 + S3);
end;


function TMainTool.CreateProjectByPath(Value: string): TOrbisLHCProject;
var
   E: string;
   IsXML: boolean;
   IsORB3: boolean;
   PName: string;


begin
   result := nil;
   E := ExtractFileExt(Value);
   IsXML := AnsiSameText(E,'.XML');
   IsORB3 := false;
   if IsXML then
   begin
      if not FileExists(Value) then exit;
   end
   else
   begin
      CheckBackSlash(Value);
      //if not DirectoryExists(Value + 'DET.BLK') then
      if DirectoryExists(Value + 'ORB000') then
         IsORB3 := true;
      //else
      //   exit;
   end;
   result := TORBISLHCProject.Create;
   result.Name := 'LHPtmp';//FindProjectName;
   result.Author := 'ORBIS01';
   if IsXML then
      result.Comment := 'XML'
   else
   if IsORB3 then
      result.Comment := 'ORB3'
   else
      result.Comment := 'BLK';
   result.ExternalDataDirectory := Value;
   result.ExternalParcelDirectory := '';
   result.ExportDataDirectory := '';
   result.ExportParcelDirectory := '';
   result.DataDirectory := Options.ProjectDirectory;
end;

procedure TMainTool.PrintMap;
var
   MI: TStringListElement;
begin
   MI := TStringListElement(World.ObjectModel.FindOrCreateElementName(TStringListElement,'MAPINFO'));
   MI.SetStringByName('MSD',GetAbsolutePath('MAP.MSD'));
   ExecScript(GetAbsolutePath('MAP.OIL'));
end;



procedure TMainTool.NewKatastr(const aPath: string; aID: integer);
var
   ORBFile: string;
   Projects: TOrbis01Projects;
   e: TElement;
   SL: TStringListElement;
   S: string;
   W: TEntity;

begin
   Continual := false;
   W := TEntity(World.ObjectModel.FindOrCreateElementName(TOwnerEntity,'WORK'));
   W.FreeAll;
   SL := TStringListElement.Create;
   SL.Name := 'KIMP';
   SL.SetPropertyStringByName('Path',aPath);
   SL.SetPropertyStringByName('aID',IntTOStr(aID));
   W.AddElement(SL);
   if aID < 0 then
   begin
      S := Options.ScriptDirectory;
      CHeckBackSlash(S);
      ExecuteScript := S+'Katastr_Import.oil';
      exit;
   end;
   if not DirectoryExists(aPath) then
   begin
      //ShowMessage atd...
      exit;
   end;
   Options.ActualKatastr := aID;
   ExecuteScript := Options.ImportParcelScript;

   e := World.ObjectModel.FindElementName('PROJECTS');
   ORBFile := GetKatastrFileName(aID);
   SaveKatastrData(ORBFile);
   Projects := TOrbis01Projects(e);
   Projects.AddKatastr(aPath,ORBFile,Options.ProjectDirectory);
   SaveProjects;
   SetEditorData;
end;

procedure TMainTool.SaveKatastrData(const aFileName: string);
var
   BackFileName,FileName: string;
   E: TElement;
   S: string;
begin
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   S := S + aFileName;
   S := GetAbsolutePath(S);
   FileName := S;
   BackFileName := ChangeFileExt(FileName,'.OR_');
   if FileExists(BackFileName) then
      DeleteFile(PChar(BackFileName));
   RenameFile(FileName,BackFileName);
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileAfterSave,BackFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   E := World.ObjectModel.FindElementName('KATASTR');
   if E = nil then exit;
   SaveData(E,FileName);
end;

function TMainTool.GetKatastrFileName(aID: integer): string;
begin
   result := 'KATASTR_'+IntToStr(aID)+'.orb';
end;


procedure TMainTool.LoadKatastrData(const aFileName: string);
var
   Load: TLoad;
   E: TElement;
   S,S1,S2: string;
   W: TEntity;
   SE: TStringElement;
begin
   W := TEntity(World.ObjectModel.FindOrCreateElementName(TOwnerEntity,'WORK'));
   W.FreeAll;
   ProgressText := 'ten datovho souboru katastru...';
   Application.ProcessMessages;
   S := GetAbsolutePath(aFileName);
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,S,nil);
   Application.ProcessMessages;
{$ENDIF}
   Load := TLoad.Create;
   Load.FileName := S;
   try
      Load.DoIt;
      E := Load.output;
      W.NextElement := E;
   except
      ShowMessage('Pi natn dat Katastru dolo k Chyb');
      Load.Free;
      exit;
   end;
   Load.Free;
   ExecuteScript := Options.AfterLoadKatastrScript;
   SetEditorData;
end;

procedure TMainTool.SetOnNewModelEvent(const Value: TOnNewModelEvent);
begin
  FOnNewModelEvent := Value;
end;

procedure TMainTool.ProcessUserLHCAreaDialog(NewObject: boolean;
  Area: double; Skupina: TElement; var UserID, Group, Color, Symbol,
  aresult: integer; var Props: string);
begin
   if Assigned(OnUserLHCAreaDialog) then
      OnUserLHCAreaDialog(NewObject,Area,Skupina,UserID,Group,Color,Symbol,aresult,Props);
end;

function TMainTool.QueryUserLayerCounts(LHC_KOD, LHC_Year: integer; aLayerName: string; var aCountR: TOrbis01UserLayerCounts; LHC_Splitted: boolean): boolean;
var
   aFileName, S: string;
   UData: TEntity;
   function GetLayCount(aLayType: string): integer;
   var
      Lay: TEntity;
   begin
      result := -1;
//      S := aLayType + '_' + aLayerName;
      Lay := TEntity(UData.FindElementName(aLayType + '_' + aLayerName));
      if Lay = nil then exit;
      result := Lay.Count;
   end;
begin
   result := false;
   if LHC_Splitted then
   begin
      aFileName := 'UDSL_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+'_' + aLayerName + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end
   else
   begin
      aFileName := 'USERDATA_' + LHC_KOD.ToString + '_'+ LHC_Year.ToString+ '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      aFileName := S + aFileName;
      aFileName := GetAbsolutePath(aFileName);
   end;
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,aFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(aFileName) then exit;
   result := true;
   UData := TEntity(_Load(aFileName));
   aCountR.ARE   := GetLayCount('ARE');
   aCountR.LIN   := GetLayCount('LIN');
   aCountR.LIN_K := GetLayCount('LIN_K');
   aCountR.PNT   := GetLayCount('PNT');
   aCountR.TXT   := GetLayCount('TXT');
   aCountR.NOTE  := GetLayCount('NOT');
   UData.Free;
end;

procedure TMainTool.SetOnUserLHCAreaDialog(const Value: TOnUserLHCAreaDialog);
begin
  FOnUserLHCAreaDialog := Value;
end;

procedure TMainTool.CheckUserDataForSave;
var
   ToSave: boolean;
begin
   ToSave := true;
   if Project = nil then exit;
   if Project.Modified then
   begin
      if not Options.AutoSaveUserData then
      begin
         if Assigned(OnSaveUserDataEvent) then
            OnSaveUserDataEvent(ToSave);
      end;
      if ToSave then
      begin
         if UserDataSplitted then
            SaveUserDataSplitted
         else
            SaveUserData('',false);
      end;
   end;
end;

function TMainTool.LoadUserData(_FileName: string): boolean;
var
   aFileName,anOldFileName,BackF,OldBackF: string;
   GenericName: boolean;
   Load: TLoad;
   E: TElement;
   S,S1,S2: string;
begin
   result := false;
   GenericName := false;
   if _FileName <> '' then
      aFileName := _FileName
   else
   begin
      aFileName := GetUserDataFileName;
      anOldFileName := GetUserDataOldFileName;
      GenericName := true;
   end;
   if aFileName = '' then exit;
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,aFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   if not FileExists(aFileName) then
   begin
      if GenericName then
      begin
         // kontrola stareho souboru
        {$IFDEF FILEEVENT}
         PostTextMsg(tm_FileExists,anOldFileName,nil);
         Application.ProcessMessages;
        {$ENDIF}
         if not FileExists(anOldFileName) then
         begin
            exit;   // neexistuje takze nazdar
         end
         else
         begin     // stary soubor existuje takze ho prejmenujem i pripadnou zalohu
            RenameFile(anOldFileName,aFileName);
           {$IFDEF FILEEVENT}
            PostTextMsg(tm_FileDelete,anOldFileName,nil);
            Application.ProcessMessages;
            PostTextMsg(tm_FileAfterSave,aFileName,nil);
            Application.ProcessMessages;
           {$ENDIF}
            // jeste kontrola zalohy
            BackF    := ChangeFileExt(aFileName,'.OR_');
            OldBackF := ChangeFileExt(anOldFileName,'.OR_');
           {$IFDEF FILEEVENT}
            PostTextMsg(tm_FileExists,OldBackF,nil);
            Application.ProcessMessages;
           {$ENDIF}
            if FileExists(OldBackF) then
            begin
               RenameFile(OldBackF,BackF);
              {$IFDEF FILEEVENT}
               PostTextMsg(tm_FileDelete,OldBackF,nil);
               Application.ProcessMessages;
               PostTextMsg(tm_FileAfterSave,BackF,nil);
               Application.ProcessMessages;
              {$ENDIF}
            end;
         end;
      end
      else
         exit;
   end;
   //ProgressText := 'ten datovho souboru katastru...';
   Application.ProcessMessages;
   E := World.ObjectModel.FindElementName('USERDATA');
   S := aFileName;
   Load := TLoad.Create;
   Load.FileName := S;
   try
      Load.DoIt;
      if E <> nil then
         E.Free;
      E := Load.output;
      World.ObjectModel.NextElement := E;
   except
      ShowMessage('Pi natn uivatelskch dat dolo k Chyb');
      Load.Free;
      exit;
   end;
   Load.Free;
   ExecuteScript := Options.AfterLoadUserDataScript;
   result := true;
   //SetEditorData;
end;

function TMainTool.LoadUserDataCheckSplit: boolean;
begin
   if UserDataSplitted then
      result := LoadUserDataSplitted
   else
      result := LoadUserData('');
end;


function TMainTool.LoadUserDataSplitted: boolean;
var
   Load: TLoad;
   FileName,S: string;
   UserLayersLocal: TEntity;
   UserLayers: TEntity;
   i: integer;
   ul: TOrbis01UserLayerInfo;
begin
   UserLayersLocal := TEntity(World.ObjectModel.FindOrCreateElementName(TOwnerEntity,'USERLAYERS_LOCAL'));
   UserLayers := TEntity(World.ObjectModel.Element['USERLAYERS']);
   UserLayersLocal.FreeAll;
   for i := 0 to UserLayers.LastIndex do
   begin
      ul := TOrbis01UserLayerInfo(UserLayers.Elements[i]);
      FileName := 'UDSL_' + GetUserDataLHCYearstring + '_' + ul.Name + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      FileName := S + FileName;
      FileName := GetAbsolutePath(FileName);
      {$IFDEF FILEEVENT}
         PostTextMsg(tm_FileExists,FileName,nil);
         Application.ProcessMessages;
      {$ENDIF}
      if FileExists(FileName) then
      begin
         LoadUserData(FileName);
      end;
   end;
   S := ScriptDirectory;
   CheckBackSlash(S);
   ExecuteScript := S+'AfterLoadUserData_ResetLayers.OIL';
end;

//function TMainTool.LoadUserDataSplitted: boolean;
//var
//   Load: TLoad;
//   FileName,S: string;
//   UserLayersLocal: TEntity;
//   i: integer;
//   ul: TOrbis01UserLayerInfo;
//begin
//   FileName := 'UDS_' + GetUserDataLHCYearstring  + '.orb';
//   S := Options.ProjectDirectory;
//   CheckBackSlash(S);
//   FileName := S + FileName;
//   FileName := GetAbsolutePath(FileName);
//   UserLayersLocal := TEntity(World.ObjectModel.Element['USERLAYERS_LOCAL']);
//   {$IFDEF FILEEVENT}
//      PostTextMsg(tm_FileExists,FileName,nil);
//      Application.ProcessMessages;
//   {$ENDIF}
//   if FileExists(FileName) then
//   begin
//      Load := TLoad.Create;
//      Load.FileName := FileName;
//      try
//         Load.DoIt;
//         if UserLayersLocal <> nil then
//            UserLayersLocal.Free;
//         UserLayersLocal := TEntity(Load.output);
//         World.ObjectModel.NextElement := UserLayersLocal;
//      except
//         ShowMessage('Pi natn uivatelskch dat dolo k Chyb');
//         Load.Free;
//         exit;
//      end;
//      Load.Free;
//      for i := 0 to UserLayersLocal.LastIndex do
//      begin
//         ul := TOrbis01UserLayerInfo(UserLayersLocal.Elements[i]);
//         FileName := 'UDSL_' + GetUserDataLHCYearstring + '_' + ul.Name + '.orb';
//         S := Options.ProjectDirectory;
//         CheckBackSlash(S);
//         FileName := S + FileName;
//         FileName := GetAbsolutePath(FileName);
//         LoadUserData(FileName);
//      end;
//   end;
//   S := ScriptDirectory;
//   CheckBackSlash(S);
//   ExecuteScript := S+'AfterLoadUserData_ResetLayers.OIL';
//end;

procedure TMainTool.SaveUserData(_FileName: string; ActualLayerOnly: boolean);
var
   BackFileName,FileName,aFileName: string;
   E: TElement;
   S,SAL: string;
   _SaveTo: boolean;
begin
   _SaveTo := false;
   if _FileName <> '' then
   begin
      aFileName := _FileName;
      _SaveTo := true;
   end
   else
      aFileName := GetUserDataFileName;
   SAL := 'false';
   if ActualLayerOnly then
      SAL := 'true';
   SetParam('SaveActualLayerOnly',SAL);
   if aFileName = '' then exit;
   ExecuteScript := Options.BeforeSaveUserDataScript;
   FileName := aFileName;
   BackFileName := ChangeFileExt(FileName,'.OR_');
   if FileExists(BackFileName) then
      DeleteFile(PChar(BackFileName));
   if FileExists(FileName) then
   begin
      RenameFile(FileName,BackFileName);
      {$IFDEF FILEEVENT}
         PostTextMsg(tm_FileAfterSave,BackFileName,nil);
         Application.ProcessMessages;
      {$ENDIF}
   end;
   E := World.ObjectModel.FindElementName('USERDATA');
   if E = nil then exit;
   SaveData(E,FileName);
   if not _SaveTo then
      Project.Modified := false;
   // uvolneni struktury
   E.Free;
end;


procedure TMainTool.SaveUserDataSplitted;
var
   aSplit: boolean;
   UserLayersLocal: TEntity;
   UserData: TEntity;
   W: TEntity;
   i: integer;
   ul: TOrbis01UserLayerInfo;
   e: TElement;
   FileName: string;
   BackFileName: string;
   S: string;
begin
   aSplit := GetParamAsBoolean('Split');
   if aSplit then
   begin
      W := TEntity(World.ObjectModel.Element['WORK']);
      UserLayersLocal := TEntity(W.Element['USERLAYERS_LOCAL']);
   end
   else
   begin
      S := ScriptDirectory;
      CheckBackSlash(S);
      ExecuteScript := S+'BeforeSaveUserData_CheckModify.OIL';
      UserLayersLocal := TEntity(World.ObjectModel.Element['USERLAYERS_LOCAL']);
   end;
   for i  := 0 to UserLayersLocal.LastIndex do
   begin
      ul := TOrbis01UserLayerInfo(UserLayersLocal.Elements[i]);
      if aSplit or ul.Modified then
      begin
         // backup odl file
         FileName := 'UDSL_' + GetUserDataLHCYearstring + '_' + ul.Name + '.orb';
         S := Options.ProjectDirectory;
         CheckBackSlash(S);
         FileName := S + FileName;
         FileName := GetAbsolutePath(FileName);

//         BackFileName := ChangeFileExt(FileName,'.or_');
//         if FileExists(BackFileName) then
//            DeleteFile(PChar(BackFileName));
//         if FileExists(FileName) then
//         begin
//            RenameFile(FileName,BackFileName);
//            {$IFDEF FILEEVENT}
//               PostTextMsg(tm_FileAfterSave,BackFileName,nil);
//               Application.ProcessMessages;
//            {$ENDIF}
//         end;
         SetParam('OnlyLayer','true');
         SetParam('LayerName',ul.Name);
         ExecuteScript := Options.BeforeSaveUserDataScript;
         UserData := TEntity(World.ObjectModel.Element['USERDATA']);
         SaveData(UserData,FileName);
         UserData.Free;
         SetParam('OnlyLayer','false');
      end;
   end;
//   FileName := 'UDS_' + GetUserDataLHCYearstring  + '.orb';
//   S := Options.ProjectDirectory;
//   CheckBackSlash(S);
//   FileName := S + FileName;
//   FileName := GetAbsolutePath(FileName);
//   SaveData(UserLayersLocal,FileName);
end;

procedure TMainTool.SetOnSaveUserdataEvent(const Value: TOnSaveUserDataEvent);
begin
  FOnSaveUserdataEvent := Value;
end;

function TMainTool.GetUserDataFileName: string;
var
   e: TElement;
   L: Tgis_LHC;
   LI: integer;
   LR: integer;
   S: string;
   LIF: TOrbis01LHCInfo;
begin
   result := '';
   if Continual then
   begin
      e := World.ObjectModel.Element['CONT'];
      if e = nil then exit;
      e := TEntity(e).Element['ActiveLHC'];
      if e = nil then exit;
      LIF := TOrbis01LHCInfo(TEntity(e).FindElementClass(TOrbis01LHCInfo));
      if LIF = nil then exit;
      LI := LIF.LHCNumber;
      LR := LIF.LHCYear;
   end
   else
   begin
      e := World.ObjectModel.Element['DATA'];
      if e = nil then exit;
      e := TEntity(e).Element['LHC'];
      if e = nil then exit;
      L := Tgis_LHC(TEntity(e).FindElementClass(Tgis_LHC));
      if L = nil then exit;
      LI := L.Cislo;
      LR := L.ROK;
   end;
   result := 'USERDATA_' + IntToStr(LI) + '_' + IntToStr(LR) + '.orb';
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   result := S + result;
   result := GetAbsolutePath(result);
end;



function TMainTool.GetUserDataLHCYearstring: string;
var
   aSplit: boolean;
   e: TElement;
   L: Tgis_LHC;
   LI: integer;
   LR: integer;
   S: string;
   LIF: TOrbis01LHCInfo;
begin
   result := '';
   aSplit := GetParamAsBoolean('SPLIT');
   if aSplit then
   begin
      result := GetParam('LHC_KOD') +'_'+GetParam('LHC_Year');
   end
   else
   begin
      if Continual then
      begin
         e := World.ObjectModel.Element['CONT'];
         if e = nil then exit;
         e := TEntity(e).Element['ActiveLHC'];
         if e = nil then exit;
         LIF := TOrbis01LHCInfo(TEntity(e).FindElementClass(TOrbis01LHCInfo));
         if LIF = nil then exit;
         LI := LIF.LHCNumber;
         LR := LIF.LHCYear;
      end
      else
      begin
         e := World.ObjectModel.Element['DATA'];
         if e = nil then exit;
         e := TEntity(e).Element['LHC'];
         if e = nil then exit;
         L := Tgis_LHC(TEntity(e).FindElementClass(Tgis_LHC));
         if L = nil then exit;
         LI := L.Cislo;
         LR := L.ROK;
      end;
      result := IntToStr(LI) + '_' + IntToStr(LR);
   end;
end;

function TMainTool.GetUserDataOldFileName: string;
var
   e: TElement;
   L: Tgis_LHC;
   LI: integer;
//   LR: integer;
   S: string;
   LIF: TOrbis01LHCInfo;
begin
   result := '';
   if Continual then
   begin
      e := World.ObjectModel.Element['CONT'];
      if e = nil then exit;
      e := TEntity(e).Element['ActiveLHC'];
      if e = nil then exit;
      LIF := TOrbis01LHCInfo(TEntity(e).FindElementClass(TOrbis01LHCInfo));
      if LIF = nil then exit;
      LI := LIF.LHCNumber;
//      LR := LIF.LHCYear;
   end
   else
   begin
      e := World.ObjectModel.Element['DATA'];
      if e = nil then exit;
      e := TEntity(e).Element['LHC'];
      if e = nil then exit;
      L := Tgis_LHC(TEntity(e).FindElementClass(Tgis_LHC));
      if L = nil then exit;
      LI := L.Cislo;
//      LR := L.ROK;
   end;
   result := 'USERDATA_' + IntToStr(LI) + '.orb';
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   result := S + result;
   result := GetAbsolutePath(result);
end;

procedure TMainTool.SetOnNewDATAEvent(const Value: TOnNewModelEvent);
begin
  FOnNewDATAEvent := Value;
end;

function TMainTool.GetContinual: boolean;
begin
   result := FContinual;
end;

procedure TMainTool.SetContinual(const Value: boolean);
var
   e: TElement;
begin
   if Value = FContinual then exit;
   FContinual := Value;
   ReadyForZeroActivity;
   if Value then
   begin
      CheckProjectForSave;
      Project := nil;
      CreateNewDATA;
      CreateContinualProjects;
      SetEditorData;
   end
   else
   begin
      CreateNewDATA;
      e := World.ObjectModel.FindElementName('CONT');
      if e <> nil then
         e.Free;
   end;
   EndZeroActivity;
   CHeckProjectRasters;
   CheckProjectVRS;
   CheckProjectTYP;
   if Assigned(OnContinualChangeEvent) then
      OnContinualChangeEvent(Value);
end;

procedure TMainTool.SetContinualYear(const Value: integer);
begin
  FContinualYear := Value;
end;

procedure TMainTool.SetOnContinualChangeEvent(const Value: TOnContinualChangeEvent);
begin
   FOnContinualChangeEvent := Value;
end;

procedure TMainTool.SetOnGeneralEvent(const Value: TOnGeneralEvent);
begin
  FOnGeneralEvent := Value;
end;

procedure TMainTool.CreateContinualProjects;
begin
   ExecuteScript := Options.CreateContinualProjectsScript;
end;

procedure TMainTool.SaveProjectAsContinual;
begin
   ExecuteScript := Options.SaveContinualScript;
   //SaveProjects;
end;

procedure TMainTool.SetNewProjectFromPath(const Value: string);
begin
   PostTextMsg(tm_NewProject,Value,nil);
   Application.ProcessMessages;
end;

procedure TMainTool.SetNewUserDataSplitted(const Value: boolean);
begin
  FNewUserDataSplitted := Value;
end;

procedure TMainTool.SetNextUserDataSplitted(const Value: boolean);
begin
  FNextUserDataSplitted := Value;
end;

procedure TMainTool.SetProjectFromFile(const Value: string);
begin
   LoadProjectFromFile(Value);
end;

procedure TMainTool.SetDoSaveProjectData(const Value: boolean);
begin
   SaveProjectData;
end;

procedure TMainTool.SetDoSaveProjects(const Value: boolean);
begin
   SaveProjects;
end;

procedure TMainTool.LoadRasters;
var
   S: string;
   E: TElement;
begin
   E := World.ObjectModel.FindElementName('RASTERS');
   if E <> nil then exit;
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Rasters_Load.OIL';
end;

procedure TMainTool.SaveRasters;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Rasters_Save.OIL';
end;

procedure TMainTool.CHeckProjectRasters;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Rasters_Project_Check.OIL';
end;

procedure TMainTool.SaveProjectRasters;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Rasters_Project_Save.OIL';
end;

procedure TMainTool.SetOnRastersChangeEvent(const Value: TOnNewModelEvent);
begin
  FOnRastersChangeEvent := Value;
end;

procedure TMainTool.SetRastersChange(const Value: boolean);
begin
   if Value then
   if Assigned(OnRasterschangeEvent) then
      OnRastersChangeEvent;
end;

procedure TMainTool.SetupProjectRasters;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Rasters_Project_Dialog.OIL';
end;

procedure TMainTool.SetScriptSender(const Value: TElement);
begin
  FScriptSender := Value;
end;

procedure TMainTool.LoadKatastrs;
var
   S: string;
   E: TElement;
begin
   E := World.ObjectModel.FindElementName('KATASTRS');
   if E <> nil then exit;
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Katastrs_Load.OIL';
end;

procedure TMainTool.SaveKatastrs;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Katastrs_Save.OIL';
end;

procedure TMainTool.LoadKatastr(aID: integer);
var
   S: string;
begin
   Options.ActualKatastr := aID;
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'Katastr_Load.OIL';
end;

procedure TMainTool.CheckProjectVRS;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'VRS_Project_Check.OIL';
end;

procedure TMainTool.SaveProjectVRS;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'VRS_Project_Save.OIL';
end;

procedure TMainTool.SetupProjectVRS;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'VRS_Project_Dialog.OIL';
end;

procedure TMainTool.SetUserDataSplitted(const Value: boolean);
begin
  FUserDataSplitted := Value;
end;

function TMainTool.SetUserDataUUID(LHC_KOD, LHC_Year: integer; aUserID: string; SetUserID: boolean): boolean;
var
   S: string;
   W,UserLayers,Userdata: TEntity;
   FileName: string;
   Li: TOrbis01LHCInfo;
   Projects: TOrbis01Projects;
   splitted: boolean;
   i: integer;
   _Load: TLoad;
   ul: TOrbis01UserLayerInfo;


   function _LoadUData(_FileName: string): boolean;
   var
      aFileName,anOldFileName,BackF,OldBackF: string;
      GenericName: boolean;
      Load: TLoad;
      E: TElement;
   begin
      result := false;
      aFileName := _FileName;
      if aFileName = '' then exit;
   {$IFDEF FILEEVENT}
      PostTextMsg(tm_FileExists,aFileName,nil);
      Application.ProcessMessages;
   {$ENDIF}
      if not FileExists(aFileName) then
      begin
         exit;
      end;
      //**************************************************
      Application.ProcessMessages;
      E := W.FindElementName('USERDATA');
      Load := TLoad.Create;
      Load.FileName := aFileName;
      try
         Load.DoIt;
         if E <> nil then
            E.Free;
         E := Load.output;
         W.NextElement := E;
         Userdata := TEntity(E);
      except
         ShowMessage('Pi natn uivatelskch dat dolo k Chyb');
         Load.Free;
         exit;
      end;
      Load.Free;
      result := true;
   end;

   function _TryToSetUUID: boolean;
   var
      aLay: TEntity;
      i, j: integer;
      GE: TGeometryElement;
      e: TElement;
   begin
      result := false;
      for i := 0 to Userdata.LastIndex do
      begin
         aLay := TEntity(UserData.Elements[i]);
         if StartsText('WMS_',aLay.Name) or StartsText('TILE_',aLay.Name) then
             Continue;
         for j := 0 to aLay.LastIndex do
         begin
            e := aLay.Elements[j];
            if e is TGeometryElement then
            begin
               GE := TGeometryElement(e);
               if GE.UUID = '' then
               begin
                  result := true;
                  GE.CreateUUID;
                  GE.TimeStamp := Now;
                  if SetUserID then
                  begin
                     GE.UID := aUserID;
                  end;
               end;
            end
            else
               break;
         end;
      end;
   end;

   function _SaveUData(_FileName: string): boolean;
   var
      BackFileName: string;
   begin
      result := false;
      BackFileName := ChangeFileExt(_FileName,'.OR_');
      if FileExists(BackFileName) then
         DeleteFile(PChar(BackFileName));
      if FileExists(_FileName) then
      begin
         RenameFile(_FileName,BackFileName);
         {$IFDEF FILEEVENT}
            PostTextMsg(tm_FileAfterSave,BackFileName,nil);
            Application.ProcessMessages;
         {$ENDIF}
      end;
      SaveData(Userdata,FileName);
   end;


begin
   result := false;
   // Find LHC and scope how much is it splitted....
   Projects := TOrbis01Projects(World.ObjectModel.FindElementName('PROJECTS'));
   if Projects = nil then exit;
   LI := Projects.GetLHCInfo(LHC_KOD, LHC_Year, true);
   if LI <> nil  then
      splitted := LI.UserDataSplitted
   else
      exit;      //LHC not found .... exit
   // Load data
   W := TEntity(World.ObjectModel.Element['WORK']);
   if W <> nil then
      W.FreeAll;
   if splitted then
   begin
      UserLayers := TEntity(World.ObjectModel.Element['USERLAYERS']);
      for i := 0 to UserLayers.LastIndex do
      begin
         ul := TOrbis01UserLayerInfo(UserLayers.Elements[i]);
         FileName := 'UDSL_' + IntToStr(LHC_KOD) + '_' + IntToStr(LHC_Year) + '_' + ul.Name + '.orb';
         S := Options.ProjectDirectory;
         CheckBackSlash(S);
         FileName := S + FileName;
         FileName := GetAbsolutePath(FileName);
         {$IFDEF FILEEVENT}
            PostTextMsg(tm_FileExists,FileName,nil);
            Application.ProcessMessages;
         {$ENDIF}
         if FileExists(FileName) then
         begin
            if not _LoadUData(FileName) then continue;
            if _TryToSetUUID then
               _SaveUData(FileName);
         end;
      end;
   end
   else
   begin
      // 1. Load Old DATA
      // I dont Know if UD allready splitted, but I believe to Orbis01 ......
      // if USERDATA doesnot exist then maybe Orbis01 Lies ...
      FileName := 'USERDATA_' + IntToStr(LHC_KOD) + '_' + IntToStr(LHC_Year) + '.orb';
      S := Options.ProjectDirectory;
      CheckBackSlash(S);
      FileName := S + FileName;
      FileName := GetAbsolutePath(FileName);
      if not _LoadUData(FileName) then
      begin
         exit; // ud file probably does not exist
      end;
      if _TryToSetUUID then
         _SaveUData(FileName);
   end;

   // 4. Tell Projects about existing UUID
   if LI <> nil  then
      LI.UserDataUUIDExists := true;
   SaveProjects;
   W.FreeAll;
   result := true;
end;

procedure TMainTool.SetOnVrsChangeEvent(const Value: TOnNewModelEvent);
begin
  FOnVrsChangeEvent := Value;
end;
{$IFDEF FILEEVENT}
procedure TMainTool.SetOn_FileAfterSaveEvent(const Value: TFileEvent);
begin
  FOn_FileAfterSaveEvent := Value;
end;

procedure TMainTool.SetOn_FileBeforeLoadEvent(const Value: TFileEvent);
begin
  FOn_FileBeforeLoadEvent := Value;
end;

procedure TMainTool.SetOn_FileDeleteEvent(const Value: TFileEvent);
begin
  FOn_FileDeleteEvent := Value;
end;

procedure TMainTool.SetOn_FileExistsEvent(const Value: TFileEvent);
begin
  FOn_FileExistsEvent := Value;
end;
{$ENDIF}
procedure TMainTool.SetVrsChange(const Value: boolean);
begin
   if Value then
   if Assigned(OnVrschangeEvent) then
      OnVrsChangeEvent;
end;

function TMainTool.SplitUserData(LHC_KOD, LHC_Year: integer): boolean;
var
   S: string;
   W,UserLayersLocal,Userdata: TEntity;
   udFileName,udFileName_,udsFileName: string;
   Li: TOrbis01LHCInfo;
   Projects: TOrbis01Projects;
begin
   // 1. Load Old DATA
   result := false;
   // I dont Know if UD allready splitted, but I believe to Orbis01 ......
   // if USERDATA doesnot exist then maybe Orbis01 Lies ...
   udFileName := 'USERDATA_' + IntToStr(LHC_KOD) + '_' + IntToStr(LHC_Year) + '.orb';
   S := Options.ProjectDirectory;
   CheckBackSlash(S);
   udFileName := S + udFileName;
   udFileName := GetAbsolutePath(udFileName);
   SetParam('Split','true');
   SetParam('LHC_KOD',IntToStr(LHC_KOD));
   SetParam('LHC_Year',IntToStr(LHC_Year));
   if LoadUserData(udFileName) then
   begin
      // element USERDATA exists inside ObjectModel.WORK in this moment ....
      //    in the script was USERDATA moved to WORK because new USERDATA wil be created in ObjectModel
      //    during Saving the data
      // and in WORK is USERLAYERS_LOCAL prepared for saving ..... maybe

      // 2. Save New DATA
      SaveUserDataSplitted;
      W := TEntity(World.ObjectModel.Element['WORK']);
      if W <> nil then
         W.FreeAll;


      // 3. Delete Old files
      udFileName_ := ChangeFileExt(udFileName,'.or_');
      DelFil(udFileName);
      DelFil(udFileName_);
   end;

   // 4. Tell Projects about Split
   Projects := TOrbis01Projects(World.ObjectModel.FindElementName('PROJECTS'));
   if Projects = nil then exit;

   LI := Projects.GetLHCInfo(LHC_KOD, LHC_Year, true);
   if LI <> nil  then
      LI.UserDataSplitted := true;
   SaveProjects;
   SetParam('Split','false');
end;

function TMainTool.Synchronize_with_mobile_user_data_layer(aLayer, MobileFile,  DesktopFile, MediaFile: string): integer;
var
   WP: TOwnerEntity;                    // workplace ... hristatko
   MData,cec: TComplicatedGECollection;     // mobilni data
   DData: TOwnerEntity;                 // desktopova data
   MExists,DExists: boolean;            // existence jednech nebo druhych dat
   GEC,RGE: TGeometryElementCollection;
   BkFileEvents: boolean;
   e_: TElement;
   eRIP: TGeometryElementRIP;
   S: string;
   i,ii: integer;
   SL: TStringlist;
   NN: TGis_Note;
   Dif, Dif1: boolean;
   DupL: boolean;
//   results:
//   00      ani jeden soubor neexistuje
//   10      mobilni soubor existuje, Desktop vytvoren
//   01      tedy 1 Desktop existuje, Mobil vytvoren
//   40      mobilni soubor existuje, byl opraven - Desktop vytvoren
//   04      tedy 4 Desktop existuje, byl opraven - Mobil vytvoren
//   11      Oba existuji, probehla synchronizace
//   55      Oba existuji a jsou pravdepodobne stejne
//   02      Nesouhlasi nazvy vrstev
//   30      Mobilni soubor chyba ... vadna struktura a tak
//   03      Desktop             --"--
// ----------------------------------------------------------------------------------------------

   function Get_UIDAttrib(_E: TElement; var _UUID: string; var _UID: string; var _TS: TDateTime): boolean;
   var
      _N: TGis_Note;
      _GE: TGeometryElement;
   begin
      result := true;
      if _e is Tgis_Note  then
      begin
         _N := TGis_Note(_e);
         _UUID := _N.UUID;
         _TS   := _N.TimeStamp;
         _UID  := _N.UID;
      end
      else
      if _e is TGeometryElement then
      begin
         _GE   := TGeometryElement(_e);
         _UUID := _GE.UUID;
         _TS   := _GE.TimeStamp;
         _UID  := _GE.UID;
      end
      else
         result := false;
   end;

   function Find_DeletedUUID(aEntity: TEntity; aUUID: string; var aDeletedUUIDS: TEntity): TGeometryElementRIP;
   begin
      result := nil;
      aDeletedUUIDS := nil;
      if aEntity is TComplicatedGECollection then
      begin
         result := TComplicatedGECollection(aEntity).FindDeletedUUID(aUUID);
         aDeletedUUIDS := TComplicatedGECollection(aEntity).DeletedUUIDs;
      end
      else
      if aEntity is TGeometryElementCollection then
      begin
         result := TGeometryElementCollection(aEntity).FindDeletedUUID(aUUID);
         aDeletedUUIDS := TGeometryElementCollection(aEntity).DeletedUUIDs;
      end;
   end;

   function Find_ElementByUUID(aEntity: TEntity; aUUID: string): TElement;
   begin
      result := nil;
      if aEntity is TComplicatedGECollection then
      begin
         result := TComplicatedGECollection(aEntity).FindElementByUUID(aUUID);
      end
      else
      if aEntity is TGeometryElementCollection then
      begin
         result := TGeometryElementCollection(aEntity).FindElementByUUID(aUUID);
      end;
   end;

   Function TestMultiUUIDS(aLay: TEntity; aTest: boolean; var ResultE: TEntity): boolean;
   // Make a hierarchy by the UUID and Return it as ResultE
   //    in resultE are count > 1 UUIDs only
   // Test meaning true result and exit when first count > 1 UUID appears....
   //    ResultE is nil in this case
   var
      i: integer;
      e: TElement;
      En: TEntity;
      aUUID: string;
      aUID: string;
      aTS: TDateTime;
   begin
      result := false;
      ResultE := TSortedEntity.Create;
      for i := 0 to aLay.LastIndex do
      begin
         e := aLay.Elements[i];
         if not Get_UIDAttrib(e, aUUID, aUID, aTS) then
            continue;
         En := TEntity(ResultE.FindOrCreateElementName(TRectEntity,aUUID));
         En.AddElement(e);
         if En.Count > 1 then
         begin
            result := true;
            if aTest then
            begin
               FreeAndNil(ResultE);
               exit;
            end;
         end;
      end;
      // remove from Result all count = 1
      for i := ResultE.LastIndex downto 0 do
      begin
         En := TEntity(ResultE.Elements[i]);
         if En.Count < 2 then
            ResultE.FreeElement(En);
      end;
   end;


   function Repair_Lin(EC: TGeometryElementCollection; NoTest: boolean): boolean;
   var
      EN: TEntity;
      ResE: TEntity;
      CL: TClearLines;
      FNGE: TFreeNoGeometryElements;
      FDGL: TFreeDuplicateGeometryLines;
      CNVL: TClearNoValidLines;
      i, j: integer;
      e: TElement;
      GE: TGeometryElement;
   begin
      result := false;
      // Odstraneni duplicit linii resime pokud je Nastaven Notest
      // nebo pokud existuji nasobne UUIDS
      if NoTest or TestMultiUUIDS(EC, true, ResE) then  // hledame prvni vyskyt Multi UUID
      begin
         if not NoTest then
            result := true;
         CL := TClearLines.Create;
         CL.Input := EC;
         CL.SelfTest := True;
         CL.DoIt;
         CL.Free;

         FNGE := TFreeNoGeometryElements.Create;
         FNGE.Input := EC;
         FNGE.DoIt;
         FNGE.Free;

         FDGL := TFreeDuplicateGeometryLines.Create;
         FDGL.Input := EC;
         FDGL.WithoutPrompt := true;
         FDGL.DoIt;
         FDGL.Free;

         CNVL := TClearNoValidLines.Create;
         CNVL.Input := EC;
         CNVL.WithoutPrompt := true;
         CNVL.DoIt;
         CNVL.Free;
         if NoTest then exit;                           // nechcem opravovat UUID ... asi
         if TestMultiUUIDS(EC, False, ResE) then        // tentokrat si nechame vratit strukturu ResE
         begin                                          //  a doresim nasobna UUID
            for i := 0 to ResE.LastIndex do
            begin
               EN := TEntity(ResE.Elements[i]);
               for j := 1 to EN.LastIndex do            // prvni element preskakujem ostatnim
               begin                                    // zrestaurujeme UUID
                  e := EN.Elements[j];
                  if not (e is TGeometryElement) then
                     continue;
                  GE := TGeometryElement(e);
                  GE.NewUUID := true;
               end;
            end;
            ResE.Free;                                  // ResE je potreba uvolnit .....
         end;
      end;
   end;


   function Repair_Purity_1L(aLayer: TEntity; var DuplicityL: boolean ): boolean;
   var
//      EN: TOwnerEntity;
      EC: TGeometryElementCollection;
      ee,e1: TElement;
      DeletedUUIDs: TEntity;
      aUUID, aUUID1, aUID, aUID1: string;
      aTS, aTS1: TDateTime;
      aRIP: TGeometryElementRIP;
      i: integer;
      IsLin: boolean;
   begin
      result := false;
      isLin  := false;
      EC := TGeometryElementCollection.Create;
      EC.AddAllFrom := aLayer;
      EC.Update;
      aLayer.FreeAll;
      ee := EC.FindElementClass(TElement);
      IsLin := ee is TTopolLineElement;
      if IsLin then
      begin
         DuplicityL := Repair_Lin(EC, false);        // byly duplicity Lin ?...
         if DuplicityL then
            result := true;
      end;
      for i := 0 to EC.LastIndex do
      begin
         ee := EC.Elements[i];
         if not Get_UIDAttrib(ee, aUUID, aUID, aTS) then
            continue;
                                                     // jestlipak neni ve smazanych ?
         aRIP := Find_DeletedUUID(aLayer,aUUID, DeletedUUIDs);
         if aRIP <> nil then                         // ve smazanych existuje
         begin
            if aTS > aRIP.TimeStamp then             // a pokud je ten existujici novejsi ...
            begin
               DeletedUUIDs.FreeElement(aRIP);       // odstranime smazani
               result := true;
            end
            else
            begin
               continue;                             // jinak nechame smaz a element preskocime
               result := true;
            end;
         end;
         e1 := Find_ElementByUUID(aLayer, aUUID);    // kontrola jestli v cili uz neni
         if e1 <> nil then
         begin                                       // a hele, asi je
            if not Get_UIDAttrib(e1, aUUID1, aUID1, aTS1) then
               continue;                             // tohle je teda trochu divny, ale co  ...
            if aTS > aTS1 then                       // vypada to, ze novej je novejsi ...
            begin
               aLayer.FreeElement(e1);                 // tak puvodni vyhodime ...
               aLayer.AddElement(ee);                  // a soupnem tam ten novej
               result := true;
            end;                                     // na nejaky rovnosti casu se vyprdnem, zejo
         end
         else
            aLayer.AddElement(ee);                     // pokud neexistoval tak ho jen pridame
      end;
      EC.Free;
   end;

   function Repair_purity(acec: TComplicatedGECollection; aGEC: TGeometryElementCollection; var DuplicityL: boolean): boolean;
   var
      EN: TOwnerEntity;
      EC: TGeometryElementCollection;
      ee,e1: TElement;
      aUUID, aUUID1, aUID, aUID1: string;
      aTS, aTS1: TDateTime;
      aRIP: TGeometryElementRIP;
      i: integer;
   begin
      result := false;
      if acec <> nil then
         result := Repair_Purity_1L(acec, DuplicityL);
      if aGEC <> nil then
         result := result or Repair_Purity_1L(aGEC, DuplicityL);
   end;

   function SynchroLayer(aMName,aDName: string): boolean;   // true znamena ze je rozdil...
   var
      i: integer;
      GE, GE1: TGeometryElement;
      N, N1: Tgis_Note;
      aUUID, aUID, aUID1: string;
      aTS, aTS1: TDateTime;
      aRIP: TGeometryElementRIP;
      ee,e1: TElement;
      DupL: boolean;              // Duplicity UUID u Linii
   begin
      result := false;
      DupL := false;
      cec := TComplicatedGECollection(MData.FindElementName(aMName));    // mobil
      GEC := TGeometryElementCollection(DData.FindElementName(aDName));  // desktop
      if Repair_purity(cec, GEC, DupL) then
         result := true;
      if (cec <> nil) or (GEC <> nil) then          // neco existuje - delame vyslednou vrstvu
      begin
          RGE := TGeometryElementCollection.Create;
      end
      else
         exit;                      // nic tu neni takze nazdar....
      if cec <> nil then            // mobilni vrstva je
      begin
         if GEC <> nil then         // desktop taky, synchronizujem
         begin
            for i := 0 to cec.LastIndex do
            begin
               ee := cec.Elements[i];
               if ee is Tgis_Note  then
               begin
                  N := TGis_Note(ee);
                  aUUID := N.UUID;
                  aTS := N.TimeStamp;
                  aUID := N.UID;
               end
               else
               if ee is TGeometryElement then
               begin
                  GE := TGeometryElement(ee);
                  aUUID := GE.UUID;
                  aTS := GE.TimeStamp;
                  aUID := GE.UID;
               end
               else
                  continue;
               aRIP := GEC.FindDeletedUUID(aUUID);   // neni nahodou smazan?
               if aRIP <> nil then                   // nahodou jo....
               begin
                  result := true;
                  if aRIP.TimeStamp > aTS then       // bylo to smazano jako posledni akce?
                     RGE.AddRIPElement(aRIP)
                  else
                     RGE.AddElement(ee);             // tak ne ... exhumujem ....potespanbu
               end
               else                                  // smazanej nebyl ... zkusime ho najit
               begin
                  e1 := GEC.FindElementByUUID(aUUID);
                  if e1 <> nil then                  // nojo, je tam
                  begin
                     if e1 is Tgis_Note  then
                     begin
                        N1 := TGis_Note(e1);
                        aTS1 := N1.TimeStamp;
                        aUID1 := N1.UID;
                     end
                     else
                     if e1 is TGeometryElement then
                     begin
                        GE1 := TGeometryElement(e1);
                        aTS1 := GE1.TimeStamp;
                        aUID1 := GE1.UID;
                     end;
                     // testujeme dobu zmeny .... posledni bere vsechno
                     if aTS > aTS1 then
                     begin
                        RGE.AddElement(ee);
                        result := true;  // je to jiny ... asi
                     end
                     else
                     begin
                        if not (SameDateTime(aTS, aTS1) and Sametext(aUID, aUID1)) then
                           result := true;  // je to jiny ... asi
                        RGE.AddElement(e1);
                     end;
                     // ovsem kazdopadne do z GEC vyhodime aby se to nepletlo pri zpetne kontrole
                     GEC.FreeElement(e1);
                  end
                  else
                  begin          // neni smazanej a neexistuje .. tak ho proste pridame zejo
                     result := True;
                     RGE.AddElement(ee);
                  end;
               end;
            end;
            for i := 0 to GEC.LastIndex do       // kontrola toho co v GEC zbylo ...
            begin
               result := true;                   // pokud neco zbylo tak je rozdil kazdopadne
               ee := GEC.Elements[i];
               if ee is Tgis_Note  then
               begin
                  N := TGis_Note(ee);
                  aUUID := N.UUID;
                  aTS := N.TimeStamp;
               end
               else
               if ee is TGeometryElement then
               begin
                  GE := TGeometryElement(ee);
                  aUUID := GE.UUID;
                  aTS := GE.TimeStamp;
               end
               else
                  continue;
               aRIP := nil;
               if cec.DeletedUUIDs <> nil then
                  aRIP := TGeometryElementRIP(cec.DeletedUUIDs.FindElementName(aUUID));   // hledame ve smazanych .. jinde by byt nemel
               if aRIP <> nil then                   // nahodou jo....
               begin
                  if aRIP.TimeStamp > aTS then       // bylo to smazano jako posledni akce?
                     RGE.AddRIPElement(aRIP)
                  else
                     RGE.AddElement(ee);              // tak ne ... exhumujem ....potespanbu
               end
               else                                  // smazanej nebyl ... proste ho pridame, jinde uz nebude...
                  RGE.AddElement(ee);
            end;
            if DupL then
               Repair_Lin(RGE, True);                // Byly nestovnalosti ... odstranime duplicity
            cec.FreeAll;
            cec.AddAllFrom := RGE;
            cec.DeletedUUIDs := RGE.DeletedUUIDs;
            GEC.FreeAll;
            GEC.AddAllFrom := RGE;
            GEC.DeletedUUIDs := RGE.DeletedUUIDs;
         end
         else                       // tak desktop neni, ve vysledku bude jen mobil
         begin
            result := true;
            GEC := TGeometryElementCollection.Create;
            DData.AddElement(GEC);
            GEC.Name := aDName;
            GEC.AddAllFrom := cec;
            GEC.DeletedUUIDs := cec.DeletedUUIDs;
         end;
      end
      else                          // mobilni vrstva neni zkusime Desktop
      if GEC <> nil then
      begin
         result := true;
         cec := MData.Layer[aMName];
         cec.AddAllFrom := GEC;
         cec.DeletedUUIDs := GEC.DeletedUUIDs;
      end;
   end;
// ----------------------------------------------------------------------------------------------
begin
   result := 0;
   WP := World.WorkPlace;
   // vypneme Fileevents
   BkFileEvents := No_FileEvents;
   No_FileEvents := true;
   MExists := FileExists(MobileFile);
   DExists := FileExists(DesktopFile);
   MData := nil;
   if MExists then
   begin
      e_ := _Load(MobileFile);
      if e_ is TComplicatedGECollection then
      begin
         MData := TComplicatedGECollection(e_);
         WP.AddElement(MData);
      end
      else
      begin
         result := 30;
         e_.Free;
         No_FileEvents := BkFileEvents;
         exit;
      end;
   end;
   if DExists then
   begin
      e_ := _Load(DesktopFile);
      if e_ is TOwnerEntity then
      begin
         DData := TOwnerEntity(e_);
         WP.AddElement(DData);
      end
      else
      begin
         result := 03;
         e_.Free;
         No_FileEvents := BkFileEvents;
         exit;
      end;
   end;
   if not (MExists or DExists) then exit;   // result 0 nic se nedeje
   if not (MExists and DExists) then        // jeden nebo druhy chybi
   begin
      if MExists then                       // Mobil existuje vytvorime Desktop
      begin
         result := 10;
         DData := TOwnerEntity.Create;
         WP.AddElement(DData);
         DData.Name := 'USERDATA';
         for i := 0 to MData.LastIndex do
         begin
            cec := MData.Layers[i];
            GEC := TGeometryElementCollection.Create;
            DData.AddElement(GEC);
            if cec.Name = 'A' then
               GEC.Name := 'ARE_'+aLayer
            else
            if cec.Name = 'L' then
               GEC.Name := 'LIN_K_'+aLayer
            else
            if cec.Name = 'N' then
               GEC.Name := 'NOT_'+aLayer;
            if Repair_purity(cec, nil, DupL) then
            begin
               result := 40;
               _Save(MData, MobileFile);
            end;
            GEC.AddAllFrom := cec;
            GEC.DeletedUUIDs := cec.DeletedUUIDs;
            GEC.Update;
         end;
         _Save(DData, DesktopFile);
      end
      else
      begin                                 // Desktop existuje vytvorime Mobil
         result := 01;
         MData := TComplicatedGECollection.Create;
         WP.AddElement(MData);
         MData.Name := aLayer;
         MData.Text := aLayer;
         for i := 0 to DData.LastIndex do
         begin
            e_ := DData.Elements[i];
            if not (e_ is TGeometryElementCollection) then continue;
            GEC := TGeometryElementCollection(e_);
            if StartsText('ARE_',GEC.Name)  then
               S := 'A'
            else
            if StartsText('LIN_K_',GEC.Name)  then
               S := 'L'
            else
            if StartsText('NOT_',GEC.Name)  then
               S := 'N'
            else
               Continue;
            if Repair_purity(nil, GEC, DupL) then
            begin
               result := 04;
               _Save(DData, DesktopFile);
            end;
            cec := MDATA.Layer[S];
            cec.AddAllFrom := GEC;
            cec.DeletedUUIDs := GEC.DeletedUUIDs;
         end;
         _Save(MData, MobileFile);
      end;
   end
   else
   begin                                    // oba existuji, budem synchronizovat
      result := 11;
      Dif := false;
      // Plochy
      Dif1 := SynchroLayer('A','ARE_'+aLayer);
      Dif := Dif or Dif1;
      // Linie
      Dif1 := SynchroLayer('L','LIN_K_'+aLayer);
      Dif := Dif or Dif1;
      // Poznamky
      Dif1 := SynchroLayer('N','NOT_'+aLayer);
      Dif := Dif or Dif1;
      if not Dif then result := 55;
{$IFDEF TEST}
      world.WorkPlace.FreeAll;
      World.WorkPlace.AddElement(MDATA);
      exit;
{$ENDIF}
      _Save(MData, MobileFile);
      _Save(DData, DesktopFile);

   end;
   // jeste medialni soubor ....
   SL := TStringList.Create;
   // touhle dobou by tu mely byt obe cesti mobilni i desktopova
   e_ := MData.FindElementName('N');
   if e_ <> nil then
   begin
      cec := TComplicatedGECollection(e_);
      for i := 0 to cec.LastIndex do
      begin
         e_ := cec.Elements[i];
         if e_ is Tgis_Note then
         begin
            NN := Tgis_Note(e_);
            if not NN.NoImages then
            for ii := 0 to NN.Images.LastIndex do
               SL.Add(NN.Images.Names[ii]);
            if not NN.NoAudios then
            for ii := 0 to NN.Audios.LastIndex do
               SL.Add(NN.Audios.Names[ii]);
         end;
      end;
      SL.SaveToFile(MediaFile);
   end;
   SL.Free;
   WP.FreeAll;
   // ... a vratime Fileevents
   No_FileEvents := BkFileEvents;
end;

function TMainTool.Synchronize_with_New_user_data_layer(aLayer, NewFile, DesktopFile, MediaFile: string): integer;
var
   WP: TOwnerEntity;                    // workplace ... hristatko
   DData,NData,MData: TOwnerEntity;     // desktopova/nova data/data pro media
   NExists,DExists: boolean;            // existence jednech nebo druhych dat
   GEC,NGEC,RGE: TGeometryElementCollection;
   BkFileEvents: boolean;
   e: TElement;
   eRIP: TGeometryElementRIP;
   S: string;
   i,ii: integer;
   SL: TStringlist;
   NN: TGis_Note;
   Dif, Dif1: boolean;
//   results:
//   00      ani jeden soubor neexistuje
//   10      Nov soubor existuje, Desktop ne ... zadna akce
//   01      tedy 1 Desktop existuje, Nov ne ... zadna akce
//   11      Oba existuji, probehla synchronizace
//   55      Oba existuji a jsou pravdepodobne stejne
//   02      Nesouhlasi nazvy vrstev ... to by se tady asi stat nemelo ....
//   30      Nov soubor chyba ... vadna struktura a tak
//   03      Desktop             --"--
// ----------------------------------------------------------------------------------------------
   function SynchroLayer(aDName: string): boolean;   // true znamena ze je rozdil...
   var
      i: integer;
      GE, GE1: TGeometryElement;
      N, N1: Tgis_Note;
      aUUID, aUID, aUID1: string;
      aTS, aTS1: TDateTime;
      aRIP: TGeometryElementRIP;
      ee,e1: TElement;
   begin
      result := false;
      NGEC := TGeometryElementCollection(NData.FindElementName(aDName));  // Novoty
      GEC  := TGeometryElementCollection(DData.FindElementName(aDName));  // desktop
      if (NGEC <> nil) or (GEC <> nil) then          // neco existuje - delame vyslednou vrstvu
      begin
          RGE := TGeometryElementCollection.Create;
      end
      else
         exit;                      // nic tu neni takze nazdar....
      if NGEC <> nil then           // nova vrstva je
      begin
         if GEC <> nil then         // desktop taky, synchronizujem
         begin
            for i := 0 to NGEC.LastIndex do
            begin
               e := NGEC.Elements[i];
               if e is Tgis_Note  then
               begin
                  N := TGis_Note(e);
                  aUUID := N.UUID;
                  aTS := N.TimeStamp;
                  aUID := N.UID;
               end
               else
               if e is TGeometryElement then
               begin
                  GE := TGeometryElement(e);
                  aUUID := GE.UUID;
                  aTS := GE.TimeStamp;
                  aUID := GE.UID;
               end
               else
                  continue;
               aRIP := GEC.FindDeletedUUID(aUUID);   // neni nahodou smazan?
               if aRIP <> nil then                   // nahodou jo....
               begin
                  result := true;
                  if aRIP.TimeStamp > aTS then       // bylo to smazano jako posledni akce?
                     RGE.AddRIPElement(aRIP)
                  else
                     RGE.AddElement(e);              // tak ne ... exhumujem ....potespanbu
               end
               else                                  // smazanej nebyl ... zkusime ho najit
               begin
                  e1 := GEC.FindElementByUUID(aUUID);
                  if e1 <> nil then                  // nojo, je tam
                  begin
                     if e1 is Tgis_Note  then
                     begin
                        N1 := TGis_Note(e1);
                        aTS1 := N1.TimeStamp;
                        aUID1 := N1.UID;
                     end
                     else
                     if e1 is TGeometryElement then
                     begin
                        GE1 := TGeometryElement(e1);
                        aTS1 := GE1.TimeStamp;
                        aUID1 := GE1.UID;
                     end;
                     // testujeme dobu zmeny .... posledni bere vsechno
                     if aTS > aTS1 then
                     begin
                        RGE.AddElement(e);
                        result := true;  // je to jiny ... asi
                     end
                     else
                     begin
                        if not (SameDateTime(aTS, aTS1) and Sametext(aUID, aUID1)) then
                           result := true;  // je to jiny ... asi
                        RGE.AddElement(e1);
                     end;
                     // ovsem kazdopadne do z GEC vyhodime aby se to nepletlo pri zpetne kontrole
                     GEC.FreeElement(e1);
                  end
                  else
                  begin          // neni smazanej a neexistuje .. tak ho proste pridame zejo
                     result := True;
                     RGE.AddElement(e);
                  end;
               end;
            end;
            for i := 0 to GEC.LastIndex do       // kontrola toho co v GEC zbylo ...
            begin
               result := true;                   // pokud neco zbylo tak je rozdil kazdopadne
               e := GEC.Elements[i];
               if e is Tgis_Note  then
               begin
                  N := TGis_Note(e);
                  aUUID := N.UUID;
                  aTS := N.TimeStamp;
               end
               else
               if e is TGeometryElement then
               begin
                  GE := TGeometryElement(e);
                  aUUID := GE.UUID;
                  aTS := GE.TimeStamp;
               end
               else
                  continue;
               aRIP := nil;
               if NGEC.DeletedUUIDs <> nil then
                  aRIP := TGeometryElementRIP(NGEC.DeletedUUIDs.FindElementName(aUUID));   // hledame ve smazanych .. jinde by byt nemel
               if aRIP <> nil then                   // nahodou jo....
               begin
                  if aRIP.TimeStamp > aTS then       // bylo to smazano jako posledni akce?
                     RGE.AddRIPElement(aRIP)
                  else
                     RGE.AddElement(e);              // tak ne ... exhumujem ....potespanbu
               end
               else                                  // smazanej nebyl ... proste ho pridame, jinde uz nebude...
                  RGE.AddElement(e);
            end;
            NGEC.FreeAll;
            NGEC.AddAllFrom := RGE;
            NGEC.DeletedUUIDs := RGE.DeletedUUIDs;
            GEC.FreeAll;
            GEC.AddAllFrom := RGE;
            GEC.DeletedUUIDs := RGE.DeletedUUIDs;
         end
         else                       // tak desktop neni, ve vysledku bude jen to nove
         begin
            result := true;
            GEC := TGeometryElementCollection.Create;
            DData.AddElement(GEC);
            GEC.Name := aDName;
            GEC.AddAllFrom := NGEC;
            GEC.DeletedUUIDs := NGEC.DeletedUUIDs;
         end;
      end
      else                          // Nova vrstva neni zkusime Desktop
      if GEC <> nil then
      begin
         result := true;
         NGEC := TGeometryElementCollection.Create;
         DData.AddElement(NGEC);
         NGEC.Name := aDName;
         NGEC.AddAllFrom := GEC;
         NGEC.DeletedUUIDs := GEC.DeletedUUIDs;
      end;
   end;
// ----------------------------------------------------------------------------------------------
begin
   result := 0;
   WP := World.WorkPlace;
   // vypneme Fileevents
   BkFileEvents := No_FileEvents;
   No_FileEvents := true;
   NExists := FileExists(NewFile);
   DExists := FileExists(DesktopFile);
   NData := nil;
   if NExists then
   begin
      e := _Load(NewFile);
      if e is TOwnerEntity then
      begin
         NData := TOwnerEntity(e);
         e := NData.FindElementClass(TComplicatedGECollection);
         if e <> nil then
         begin
            result := 30;
            NDATA.Free;
            No_FileEvents := BkFileEvents;
            exit;
         end;
         WP.AddElement(NData);
      end
      else
      begin
         result := 30;
         e.Free;
         No_FileEvents := BkFileEvents;
         exit;
      end;
   end;
   if DExists then
   begin
      e := _Load(DesktopFile);
      if e is TOwnerEntity then
      begin
         DData := TOwnerEntity(e);
         e := DData.FindElementClass(TComplicatedGECollection);
         if e <> nil then
         begin
            result := 03;
            DDATA.Free;
            No_FileEvents := BkFileEvents;
            exit;
         end;
         WP.AddElement(DData);
      end
      else
      begin
         result := 03;
         e.Free;
         No_FileEvents := BkFileEvents;
         exit;
      end;
   end;
   if not (NExists or DExists) then exit;   // result 0 nic se nedeje
   if not (NExists and DExists) then        // jeden nebo druhy chybi
   begin
      if NExists then                       // Novy existuje vytvorime Desktop
      begin
         result := 10;
         _Save(NData, DesktopFile);
         MData := NData;
      end
      else
      begin                                 // Desktop existuje vytvorime Novy (jestli to teda neni blbost)
         result := 01;
         _Save(DData, NewFile);
         MData := DData;
      end;
   end
   else
   begin                                    // oba existuji, budem synchronizovat
      result := 11;
      Dif := false;
      // Plochy
      Dif1 := SynchroLayer('ARE_'+aLayer);
      Dif := Dif or Dif1;
      // Linie
      Dif1 := SynchroLayer('LIN_K_'+aLayer);
      Dif := Dif or Dif1;
      // Poznamky
      Dif1 := SynchroLayer('NOT_'+aLayer);
      Dif := Dif or Dif1;
      if not Dif then result := 55;

      _Save(NData, NewFile);
      _Save(DData, DesktopFile);

      MData := NData;
   end;
   // jeste medialni soubor ....
   SL := TStringList.Create;
   // zdroj pro media by mel byt v MDATA
   e := MData.FindElementName('NOT_'+aLayer);
   if e <> nil then
   begin
      GEC := TGeometryElementCollection(e);
      for i := 0 to GEC.LastIndex do
      begin
         e := GEC.Elements[i];
         if e is Tgis_Note then
         begin
            NN := Tgis_Note(e);
            if not NN.NoImages then
            for ii := 0 to NN.Images.LastIndex do
               SL.Add(NN.Images.Names[ii]);
            if not NN.NoAudios then
            for ii := 0 to NN.Audios.LastIndex do
               SL.Add(NN.Audios.Names[ii]);
         end;
      end;
      SL.SaveToFile(MediaFile);
   end;
   SL.Free;
   WP.FreeAll;
   // ... a vratime Fileevents
   No_FileEvents := BkFileEvents;
end;

procedure TMainTool.LoadUserLayers;
var
   S: string;
   E: TElement;
begin
   // nejprve kontrola a nacteni sdilenych vrstev
   E := World.ObjectModel.FindElementName('USERLAYERS_SHARED');
   if E = nil then
   begin
      S := ScriptDirectory;
      CHeckBackSlash(S);
      ExecuteScript := S+'UserLayers_LoadShared.OIL';
   end;
   E := World.ObjectModel.FindElementName('USERLAYERS');
   if E = nil then
   begin
      S := ScriptDirectory;
      CHeckBackSlash(S);
      ExecuteScript := S+'UserLayers_Load.OIL';
   end;
end;

procedure TMainTool.SaveUserLayers;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'UserLayers_Save.OIL';
end;

procedure TMainTool.SetActualEditLayer(const Value: string);
begin
   //FActualEditLayer := Value;
   _USR := Value;   // tohle neni berlicka ale berla jako krava
end;

procedure TMainTool.SetActualEditLayerChanged(const Value: boolean);
var
   En: TEntity;
   Eli: TOrbis01UserLayerInfo;
begin
   En := EditLayers;
   if EN = nil then exit;
   Eli := TOrbis01UserLayerInfo(En.FindElementName(ActualEditLayer));
   if Eli <> nil then
      Eli.Modified := Value;
end;

function TMainTool.GetActualEditLayer: string;
begin
   result := _USR;
   //if result = '' then
   //   result := 'USR';
end;

function TMainTool.GetActualEditLayerChanged: boolean;
var
   En: TEntity;
   Eli: TOrbis01UserLayerInfo;
begin
   result := false;
   En := EditLayers;
   if EN = nil then exit;
   Eli := TOrbis01UserLayerInfo(En.FindElementName(ActualEditLayer));
   if Eli <> nil then
      result := Eli.Modified;
end;

procedure TMainTool.SetDataProfileName(const Value: string);
begin
  FDataProfileName := Value;
end;

procedure TMainTool.SetDoLoadMaps(const Value: boolean);
begin
   if Value then
      LoadMaps;
end;

procedure TMainTool.SetDoSaveMaps(const Value: boolean);
begin
   if Value then
      SaveMaps;
end;

procedure TMainTool.SetOnMapsCHangeEvent(const Value: TOnNewModelEvent);
begin
  FOnMapsCHangeEvent := Value;
end;

procedure TMainTool.SetMapsChange(const Value: boolean);
begin
   if Value then
   if Assigned(OnMapschangeEvent) then
      OnMapsChangeEvent;
end;

procedure TMainTool.CheckProjectTYP;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'TYP_Project_Check.OIL';
end;

procedure TMainTool.SaveProjectTYP;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'TYP_Project_Save.OIL';
end;

procedure TMainTool.SetOnTypChangeEvent(const Value: TOnNewModelEvent);
begin
  FOnTypChangeEvent := Value;
end;

procedure TMainTool.SetTypChange(const Value: boolean);
begin
   if Value then
   if Assigned(OnTypchangeEvent) then
      OnTypChangeEvent;
end;

procedure TMainTool.SetupProjectTYP;
var
   S: string;
begin
   S := ScriptDirectory;
   CHeckBackSlash(S);
   ExecuteScript := S+'TYP_Project_Dialog.OIL';
end;

END.
